package com.japisoft.editix.action.dtdschema;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Date;

import javax.swing.AbstractAction;

import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.ui.toolkit.BrowserCaller;
import com.japisoft.framework.ui.toolkit.FileManager;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

import net.sf.xframe.xsddoc.Processor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class GenerateXSDDoc extends AbstractAction {

	@Override
	public void actionPerformed(ActionEvent arg0) {

		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container.getCurrentDocumentLocation() == null ) {
			EditixFactory.buildAndShowErrorDialog( "Please save your Schema before" );
			return;
		}
		IXMLPanel panel = EditixFrame.THIS.getSelectedPanel();
		// Generate the new schema
		panel.prepareToSave();
		
		File f = FileManager.getSelectedDirectory();

		if ( f != null ) {

			try {
		    	Processor p = new Processor();
		    	p.setDoctitle( "Documentation Generated at " + new Date() );
		    	p.setSchemaLocation( container.getCurrentDocumentLocation() );
		    	p.setOut( f.toString() );
		    	p.execute();
		    	
		    	BrowserCaller.displayURL( new File( f, "index.html" ).toString() );

			} catch( Exception exc ) {
				exc.printStackTrace();
				EditixFactory.buildAndShowErrorDialog( "Can't generate : " + exc.getMessage() );
			}
			
		}
		
	}

}
