package com.japisoft.editix.action.dtdschema.generator;

import java.util.HashMap;

import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SchemaGenerator {

	public static MetaNode getMetaModel( FPNode root ) {
		FPNode documentRoot = new FPNode( FPNode.DOCUMENT_NODE, null );
		documentRoot.appendChild( root );

		MetaNode metaRoot = new MetaNode( documentRoot, new HashMap<String, MetaNode>() );
		metaRoot.manageAttributes( documentRoot );
		metaRoot.manageChildren( documentRoot );
		metaRoot.manageMissing( documentRoot );
		
		return metaRoot;
	}

	public static String generate(
			MetaNode metaRoot,
			Transformer transformer ) {
		String newDocument = transformer.transform( ( MetaNode )metaRoot.getChildren().get( 0 ), metaRoot.getNodeCollection() );
		return newDocument;
	}
	
	public static String generate( 
			FPNode root, 
			Transformer transformer ) {
		MetaNode metaRoot = getMetaModel( root );
		return generate( metaRoot, transformer );
	}

}
