package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.application.descriptor.ActionModel;
import com.japisoft.editix.action.search.BookmarkAction;
import com.japisoft.editix.action.search.RemoveBookmarksAction;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CloseAction extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		XMLContainer container = null;

		if ( e.getSource() instanceof IXMLPanel ) {
			container = ( ( IXMLPanel )e.getSource() ).getMainContainer();
		} else
			container = EditixFrame.THIS.getSelectedContainer();

		if ( container != null ) {
			if ( container.getEditor().isDocumentModified() ) {
				if ( EditixFactory.buildAndShowChoiceDialog( "Save this document before closing ?" ) == JOptionPane.YES_OPTION ) {
					ActionModel.activeActionById( "save", e );				
				} else {
//					if ( EditixFactory.buildAndShowChoiceDialog( "Are you sure to close it ?" ) == JOptionPane.NO_OPTION )
//						return;
				}
			}
			
			String f = container.getCurrentDocumentLocation();
			String encoding = container.getDocumentInfo().getEncoding();
			String type = container.getDocumentInfo().getType();
			
			BookmarkAction.storeBookmarksInContainer( container );
			RemoveBookmarksAction.cleanBookmarks();
			OpenAction.synchronizedRecentFileMenu( container, f, type, encoding );
			EditixFrame.THIS.closeContainer( container.getView() );
			
			ApplicationModel.fireApplicationValue( "close", container );
		}
	}

}
