package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;
import java.util.Stack;

import javax.swing.AbstractAction;
import javax.swing.Action;
import com.japisoft.editix.action.file.PreviousSelectionAction.StackItem;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NextSelectionAction extends AbstractAction {

	static Stack STACK_NEXT = null;
	static Action ref = null;
	
	public NextSelectionAction() {
		ref = this;
	}

	public void actionPerformed(ActionEvent e) {
		StackItem item = ( StackItem )STACK_NEXT.pop();
		PreviousSelectionAction.selectOrOpen( item );
		ref.setEnabled( STACK_NEXT.size() > 0 );
		PreviousSelectionAction.resetToolTip( STACK_NEXT, this );
	}

	static void addNextPath( StackItem item ) {
		if ( STACK_NEXT == null ) {
			STACK_NEXT = new Stack();
		}
		STACK_NEXT.remove(
				item
		);
		STACK_NEXT.push( 
				item		
		);
		PreviousSelectionAction.resetToolTip( STACK_NEXT, ref );
		PreviousSelectionAction.checkForSize( STACK_NEXT );		
		ref.setEnabled( STACK_NEXT.size() > 0 );
	}

}
