package com.japisoft.editix.action.file;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;

import com.japisoft.editix.project.ProjectManager;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RenameAction extends AbstractAction {
	public void actionPerformed(ActionEvent e) {
		XMLContainer container = EditixFrame.THIS.getSelectedContainer();		
		if ( container != null ) {
			if ( container.getCurrentDocumentLocation() == null )
				EditixFactory.buildAndShowErrorDialog( "No location for this document" );
			else {
				String currentName = container.getDocumentInfo().getDocumentName();
				String newName = EditixFactory.buildAndShowInputDialog( "Rename", currentName );
				if ( newName != null ) {
					String oldLocation = container.getCurrentDocumentLocation();
					File f = new File( container.getCurrentDocumentLocation() );
					File f2 = null;
					if ( !f.renameTo(
							f2 = new File( f.getParentFile(), newName ) ) ) {
						EditixFactory.buildAndShowErrorDialog( "Can't rename to " + newName );
					} else {
						container.getDocumentInfo().setCurrentDocumentLocation(
								f2.toString() );
						EditixFrame.THIS.refreshCurrentTabName();
						ProjectManager.updateFilePath( oldLocation, f2.toString() );
					}
				}
			}
		}
	}
}
