package com.japisoft.editix.action.file.imp;

import javax.swing.ComboBoxModel;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class JDBCDriverListModel implements ListModel, ComboBoxModel, JDBCDriverModelListener {

	private JDBCDriverModel model = null;

	public JDBCDriverListModel( JDBCDriverModel model ) {
		this.model = model;
		this.model.setListener( this );
		if ( model.size() > 0 )
			item = model.getDriver( 0 );
	}
	
	public void modelUpdated() {
		if ( l != null ) {
			l.contentsChanged( 
				new ListDataEvent( this, ListDataEvent.CONTENTS_CHANGED, 0, getSize() - 1 ) 
			);
		}
	}

	private ListDataListener l;
	
	public void addListDataListener(ListDataListener l) {
		this.l = l;
	}
	public void removeListDataListener(ListDataListener l) {
		this.l = null;
	}

	public Object getElementAt(int index) {
		return model.getDriver( index );
	}

	public int getSize() {
		return model.size();
	}
	
	public Object getSelectedItem() {
		return item;
	}

	private Object item;
	
	public void setSelectedItem(Object anItem) {
		this.item = anItem;
	}

}
