package com.japisoft.editix.action.file.imp;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

import com.japisoft.editix.action.xml.format.FormatAction;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.format.FormatterConfig;
import com.japisoft.xflows.task.SwingActionTaskContext;
import com.japisoft.xflows.task.imp.json.JSonFileRunner;
import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

import java.awt.event.ActionEvent;
import java.io.File;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class JSONImportAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {
		JFileChooser fc = EditixFactory.buildFileChooser( new FileFilter() {			
			@Override
			public String getDescription() {
				return "JSON file (*.json, *.jso)";
			}
			@Override
			public boolean accept( File f ) {
				if ( f.isFile() ) {
					String tmp = f.getName().toLowerCase();
					return tmp.endsWith( ".json" ) || tmp.endsWith( ".jso" );
				} else
					return true;
			}
		});
		if ( fc.showOpenDialog( EditixFrame.THIS ) == 
				JFileChooser.APPROVE_OPTION ) {
			File sourceFile = fc.getSelectedFile();
			JSonFileRunner runner = new JSonFileRunner();
			SwingActionTaskContext satc = new SwingActionTaskContext( sourceFile );
			runner.run( satc );
			if ( !satc.hasErrorFound() ) {
				IXMLPanel panel = EditixFactory.buildNewContainer( "XML", ( String )null );
				XMLContainer container = panel.getMainContainer();
				container.setText( satc.getTaskResult() );
				FormatAction.format(
					container,
					null,
					new FormatterConfig(),
					null
				);
				EditixFrame.THIS.addContainer( panel );
			}
		}
	}

}
