package com.japisoft.editix.action.file.imp;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SQLImportAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {

		File jdbcDrivers = new File( 
			EditixApplicationModel.getAppUserPath(), 
			"jdbcdrivers.xml" 
		); 

		JDBCDriverModel m = new JDBCDriverModel();

		if ( jdbcDrivers.exists() ) {
			try {
				m.read( jdbcDrivers	);
			} catch( Exception exc ) {
				EditixApplicationModel.debug( exc );
			}
		}

		m.addDriver( JDBCDriver.ODBC_DRIVER );

		SQLImportPanel p = new SQLImportPanel();

		p.setDriverModel( m );

		if (
			DialogManager.showDialog( 
					EditixApplicationModel.MAIN_FRAME, 
					"SQL Import", 
					"SQL Import", 
					"Choose a driver and run your SQL query for converting to XML", 
					null,
					p ) == DialogManager.OK_ID ) {
			
			try {
				
				m.removeDriver( JDBCDriver.ODBC_DRIVER );

				// Save the driver model
				m.write( 
						jdbcDrivers
				);

			} catch( Exception exc ) {
				EditixApplicationModel.debug( exc );
			}
		}

		try {
			p.storeState();
		} catch( Exception exc ) {
			EditixFactory.buildAndShowWarningDialog( "Can't save user parameters : [" + exc.getMessage() + "]" );
		}
	}

}
