package com.japisoft.editix.action.file.project;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;

import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.panels.project2.DefaultProject;
import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.application.descriptor.ActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class OpenProjectAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {
		
		ProjectFileChooser pfc = new ProjectFileChooser();
		if ( pfc.showOpenDialog( ApplicationModel.MAIN_FRAME ) == JFileChooser.APPROVE_OPTION ) {
			File f = pfc.getSelectedFile();
			if ( !DefaultProject.isProjectPath( f ) ) {
				EditixFactory.buildAndShowWarningDialog( "Invalid project path, please use the new project action" );
			} else {
				( ( NewProjectAction )ActionModel.restoreAction( "newp" ) ).loadProject( f );
			}
		}
		
	}

}
