package com.japisoft.editix.action.fop;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URI;
import java.net.URL;

import org.apache.fop.apps.FopFactory;

import com.japisoft.editix.main.EditixApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditixFOPFactory {
	
	public static File fopXML = new File( EditixApplicationModel.getAppUserPath(), "fop.xml" );
	
	private static FopFactory createFoFactory( URL foLocation ) throws Exception {
		Method m = null;
		try {
			m = FopFactory.class.getMethod( "newInstance", null );
			return ( FopFactory )m.invoke( null, null );
		} catch( NoSuchMethodException sme ) {
		}
		if ( m == null ) {
			// 2.0 case
			try {
				if ( fopXML.exists() )
					m = FopFactory.class.getMethod( "newInstance", File.class );
				else 
					m = FopFactory.class.getMethod( "newInstance", URI.class );
			} catch( NoSuchMethodException sme ) {
				throw new Exception( "Can't initialize fop, newInstance missing" );
			}
			
			// Can't be null
			if ( foLocation == null ) {
				File f = fopXML;
				foLocation = f.toURL();				
			}

			return ( ( FopFactory )m.invoke( null,  fopXML.exists() ? fopXML : foLocation.toURI() ) );
			
			/*
			File f = foLocation;
			if ( fopXML.exists() ) {
				f = fopXML;
			}
			
			// Can't be null
			if ( foLocation == null ) {
				File f = fopXML;
				foLocation = f.toURL();
			}

			URI uri = new URI( foLocation.toExternalForm().replace( " ", "%20" ) );

			return ( ( FopFactory )m.invoke( null,  foLocation == null ? ( URI )null : uri ) );
			*/
			
		}
		
		throw new Exception( "Can't initialize fop, newInstance missing" );
	}

	public static FopFactory newInstance( URL foLocation ) throws Exception {
		FopFactory fopfactory = createFoFactory( foLocation );
		if ( fopfactory != null ) {
			try {
				// For 1.0
				Method m2 = FopFactory.class.getMethod( "setBaseURL", String.class );
				if ( m2 != null ) {			
					// Relative access
					try {
						String strFoLocation = null;
						if ( foLocation != null )
							strFoLocation = foLocation.toExternalForm();
						m2.invoke( fopfactory, strFoLocation.replace( " ", "%20" ) );
					} catch( Exception exc ) {
					}
				}
			} catch( NoSuchMethodException sme ) {
			}
			return fopfactory;
		} else 
			throw new Exception( "Can't initialize FOP, can't create fopfactory" );		
	}

	public static void main( String[] args ) throws Exception {
		System.out.println( 
			EditixFOPFactory.newInstance( 
				new URL( "file://C:\\Program Files (x86)\\editix-xmleditor2016\\bin" ) ) 
		);
	}

}
