package com.japisoft.editix.action.options;

import java.awt.event.ActionEvent;
import java.io.InputStream;
import java.net.URL;

import javax.swing.AbstractAction;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.ui.toolkit.BrowserCaller;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CheckVersionAction extends AbstractAction {
	
	public void actionPerformed(ActionEvent e) {
		try {
			String version = getLastVersion();
			if ( !( EditixApplicationModel.getAppVersion().trim().equals( version ) ) ) {
				EditixFactory.buildAndShowInformationDialog( "You can download the version " + version + " at http://www.editix.com" );
				BrowserCaller.displayURL( "http://www.editix.com/download.html" );
			} else
				EditixFactory.buildAndShowInformationDialog( "You have the latest version" );
		} catch( Throwable th ) {
			EditixFactory.buildAndShowErrorDialog( "Can't check the last version" );
		}
	}

	public static String getLastVersion() throws Exception {
		URL url = new URL( "http://www.editix.com/editix.ver" );
		InputStream input = url.openStream();
		StringBuffer sb = new StringBuffer();
		int c;
		while ( ( c = input.read() ) != -1 ) {
			sb.append( ( char )c );
		}
		return sb.toString().trim();
	}
	
}
