package com.japisoft.editix.action.options;

import java.awt.event.ActionEvent;
import java.net.URL;

import javax.swing.AbstractAction;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.application.descriptor.composer.DescriptorComposer;
import com.japisoft.framework.dialog.DialogManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DescriptorComposerAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {

		URL u = EditixApplicationModel.INTERFACE_BUILDER.getDocumentURL();
		
		DescriptorComposer dcPanel = new DescriptorComposer();

		DialogManager.ACTIVE_DEFAULT_BUTTON = false;

		try {
			dcPanel.loadDescriptor( u, EditixApplicationModel.getCustomEditiXDescriptor() );

			DialogManager.showDialog( 
				EditixApplicationModel.MAIN_FRAME, 
				"Application Descriptor", 
				"EditiX Application Descriptor", 
				"Update the application descriptor. Change menus/items/toolbars of EditiX. You must save and restart the application for usage", 
				null, 
				dcPanel 
			);

		} catch( Exception exc ) {
			EditixFactory.buildAndShowErrorDialog( "Can't load the editix descriptor ? : " + exc.getMessage() );
		}

		DialogManager.ACTIVE_DEFAULT_BUTTON = true;
		
	}	
	
}
