package com.japisoft.editix.action.options;

import java.awt.event.ActionEvent;
import java.io.InputStream;

import javax.swing.AbstractAction;

import com.japisoft.editix.action.xsl.result.DocumentTypeModel;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.toolkit.FileToolkit;
import com.japisoft.framework.xml.XMLFileData;
import com.japisoft.xmlpad.IXMLPanel;

// For defining zipped output document for XSLT
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TransformationDocumentModelAction extends AbstractAction {
	
	@Override
	public void actionPerformed( ActionEvent ae ) {
		InputStream input = DocumentTypeModel.instance().getModel();
		try {
			String content = FileToolkit.getContentFromInputStream(input, "UTF-8" );
			XMLFileData xdata = new XMLFileData( "UTF-8", content );
			IXMLPanel panel = EditixFactory.buildNewContainer(
				DocumentTypeModel.instance().getUserPath().toString(),
				xdata
			);
			panel.getMainContainer().setCurrentDocumentLocation( DocumentTypeModel.instance().getUserPath().toString() );
			EditixFrame.THIS.addContainer( panel );
		} catch( Throwable th ) {
			EditixFactory.buildAndShowErrorDialog( "Can't read : " + th.getMessage() );
		}		
	}
	
}
