package com.japisoft.editix.action.search;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;

import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BookmarkGoToAction extends AbstractAction {

	public void actionPerformed(ActionEvent e) {
		
		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container == null )
			return;

		container.getEditor().requestFocus();
		String loc = ( String )getValue( Action.NAME );
		if ( loc.startsWith( "Cursor at" ) ) {
			// Move the cursor to it
			int cursor = Integer.parseInt( loc.substring( 10 ) );
			container.getEditor().setCaretPosition( cursor );
		} else {

			FPNode rootNode = ( FPNode )container.getTree().getModel().getRoot();
			if ( rootNode != null ) {
				FPNode node = rootNode.getNodeForXPathLocation( loc, true );
				if ( node == null ) {
					EditixFactory.buildAndShowWarningDialog( "Can't find this node " + loc );
				} else {
					container.getEditor().setCaretPosition( node.getStartingOffset() + 1 );
				}
			}
		}

	}

}
