package com.japisoft.editix.action.search.file;

import java.io.File;

import javax.swing.JComponent;

import com.japisoft.editix.ui.panels.AbstractPanel;
import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FileSearchPanel extends AbstractPanel {

	protected JComponent buildView() {
		return new FileSearchUI();
	}

	protected String getTitle() {
		return "File search";
	}

	public void stop() {
		FileSearchUI view = ( FileSearchUI )getView();
		if ( view.mustSave() ) {
			view.saveParameters( new File( ApplicationModel.getAppUserPath(), "filesearch.cfg" ) );
		}
	}

	protected void postShow() {
		File f = new File( ApplicationModel.getAppUserPath(), "filesearch.cfg" );
		FileSearchUI view = ( FileSearchUI )getView();
		if ( f.exists() ) {
			view.readParameters( f );
		}
	}

}
