package com.japisoft.editix.action.search.file;

import java.io.File;
import java.io.FileInputStream;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;

// import org.jaxen.dom.DOMXPath;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.japisoft.framework.xml.XMLFileData;
import com.japisoft.framework.xml.XMLToolkit;
import com.japisoft.framework.xml.parser.FPParser;
import com.japisoft.framework.xml.parser.dom.DocumentImpl;
import com.japisoft.framework.xml.parser.dom.DomNodeFactory;
import com.japisoft.framework.xml.parser.node.FPNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XPathSearchEngineImpl implements SearchEngine {

	public List search( File f, String item ) {
		try {
			String l = null;
			
			/* XPath xp = XPathFactory.newInstance().newXPath();
			XPathExpression xe = xp.compile( item ); */

			ArrayList res = null;

			FPParser p = new FPParser();
			p.setNodeFactory( 
					new DomNodeFactory() 
			);

			XMLFileData xfd = XMLToolkit.getContentFromInputStream( 
					new FileInputStream( f ), 
					null 
			);

			Node nn = new DocumentImpl( (Element)p.parse(new StringReader(xfd.getContent())).getRoot() );
//			com.japisoft.fastparser.document.Document d2 = p.getDocument();
//
//			Document d = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
//			d.adoptNode( ( Element )d2.getRoot() );
//			d.appendChild( ( Element )d2.getRoot() );
			
/*
			
			org.jaxen.XPath xpath = new DOMXPath( item );			

			// NodeList nl = ( NodeList )xe.evaluate( nn , XPathConstants.NODESET );
			
			Object resTmp = xpath.evaluate( nn );
			if ( resTmp instanceof List ) {
				List nl = ( List )resTmp;
				res = new ArrayList();
				for ( int i = 0; i < nl.size(); i++ ) {
					FPNode sn = ( FPNode )nl.get( i );
					String line = xfd.getContent().substring( sn.getStartingOffset(), sn.getStoppingOffset() );
					SearchResult sr = new SearchResultImpl( line, sn.getStartingLine() - 1 );
					res.add( sr );
				}
			}

*/

			return res;
		} catch (Throwable e) {
			return null;
		}

	}

	public String toString() {
		return "XPath expression";
	}

}
