package com.japisoft.editix.action.tree;

import java.awt.event.ActionEvent;
import java.util.ArrayList;

import javax.swing.AbstractAction;
import javax.swing.JTree;
import javax.swing.tree.TreePath;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ExpandAction extends AbstractAction {
	
	private void expandNode( FPNode sn, JTree t ) {
		FPNode sni = sn;
		ArrayList l = new ArrayList();
		l.add( sn );
		while ( sn != null ) l.add( 0, sn = sn.getFPParent() );
		l.remove( 0 );
		t.expandPath( new TreePath( l.toArray() ) );
		
		for ( int i = 0; i < sni.childCount(); i++ ) {
			expandNode( sni.childAt( i ), t );
		}
	}

	public void actionPerformed(ActionEvent e) {
		XMLContainer container = 
			EditixFrame.THIS.getSelectedContainer();
		if ( container != null ) {
			JTree t = container.getTree();
			TreePath tp = t.getSelectionPath();
			if ( tp != null ) {
				FPNode sn = ( FPNode )tp.getLastPathComponent();
				if ( sn != null )
					expandNode( sn, t );
			}
		}
	}

}
