package com.japisoft.editix.action.view;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;

import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.ui.toolkit.BrowserCaller;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SystemView extends AbstractAction {

	public void actionPerformed(ActionEvent e) {		
		XMLContainer container = EditixFrame.THIS.getSelectedContainer();
		if ( container == null )
			return;

		if ( container.getCurrentDocumentLocation() != null ) {
			BrowserCaller.displayURL(
					container.getCurrentDocumentLocation() );
		} else {
			String _ = container.getText();
			if ( _.startsWith( "<?") ) {
				int i = _.indexOf( "\n" );
				if ( i > -1 )
					_ = _.substring( i );
			}
			HTMLDialog dialog = new HTMLDialog( _ );
	
			Point p = ( Point )container.getProperty( "view.html.location" );
			Dimension d =( Dimension )container.getProperty( "view.html.dimension" );
	
			if ( p != null ) 
				dialog.setLocation( p );
			if ( d != null )
				dialog.setSize( d );
	
			if ( p != null )
				dialog.setVisible( true );
			else
					dialog.setVisible( true );
	
			if ( dialog.isOk() ) {
				container.setProperty( "view.html.location", dialog.getLocation() );
				container.setProperty( "view.html.dimension", dialog.getSize() );
			}
		}
	}

	class HTMLDialog extends EditixDialog {
		HTMLDialog( String html ) {
			super( "XHTML", "HTML View", "This is a mini browser.\nSave your document for displaying it inside a system viewer" );
			JEditorPane ed = new JEditorPane( "text/html", html );	
			ed.setEditable( false );	
			getContentPane().add( new JScrollPane( ed ) );
		}
		protected Dimension getDefaultSize() {
			return new Dimension( 400, 400 );
		}
	}

}
