package com.japisoft.editix.action.xml;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.panels.diff.DiffPanel;
import com.japisoft.framework.dialog.actions.DialogActionModel;
import com.japisoft.framework.dialog.actions.StoringLocationAction;
import com.japisoft.framework.ui.toolkit.BrowserCaller;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.p3.Manager;
//import com.japisoft.xmldiff.event.XMLDiffSelection;
//import com.japisoft.xmldiff.ui.XMLDiffPanel;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLDiffActionOld extends AbstractAction { //implements XMLDiffSelection {

	public void actionPerformed( ActionEvent e ) {
		
		if ( Manager.isFree() ) {		
			EditixFactory.buildAndShowInformationDialog( "This action is not available inside the Free Edition.\nPlease look at http://www.editix.com" );
			BrowserCaller.displayURL( "http://www.editix.com" );
			return;
		}

		//
		EditixDialog dialog = new EditixDialog(
				"XML diff",
				"Compare XML documents",
				"Select both documents to compare the XML content",
				DialogActionModel.getDefaultDialogCloseActionModel().addDialogAction(
						new StoringLocationAction()		
				)		
		);

		XMLContainer container = 
			EditixFrame.THIS.getSelectedContainer();
		// XMLDiffPanel diff = null;
		//XMLPathBuilder pb = new XMLPathBuilder();

/*		if ( container != null && container.getTree() != null && container.getTree().getModel() != null && container.getTree().getModel().getRoot() instanceof SimpleNode ) {
			dialog.getContentPane().add(
					diff = new XMLDiffPanel( 
							( TreeNode )container.getTree().getModel().getRoot(), 
							container.getCurrentDocumentLocation(), pb ) 
					);
		}  else 
			dialog.getContentPane().add(
					diff = new XMLDiffPanel( pb ) 
			); */
		
		dialog.getContentPane().add( new DiffPanel( container ) );

		dialog.setSize( 650, 550 );
//		diff.setXMLDiffSelection( this );
		
		dialog.setModal( false );
		
		dialog.setVisible( true );
//		dialog.dispose();
//		diff.setXMLDiffSelection( null );
		//
	}

	public void select(String documentPath, FPNode node) {
		XMLContainer container = 
			EditixFrame.THIS.getSelectedContainer();
		if ( ( container != null && container.getCurrentDocumentLocation() == null ) || 
				documentPath.equals( container.getCurrentDocumentLocation() ) )
			container.getEditor().highlightLine( node.getStartingLine() );	
	}

}
