package com.japisoft.editix.action.xml;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.table.DefaultTableModel;

import com.japisoft.editix.action.search.XPathDialog;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.ui.toolkit.BrowserCaller;
import com.japisoft.p3.Manager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XPathBuilderAction extends AbstractAction {

	String[] items = null;
	DefaultTableModel vars = null;
	DefaultTableModel namespaces = null;

	public void actionPerformed(ActionEvent e) {
		
		if ( Manager.isFree() ) {

			EditixFactory.buildAndShowInformationDialog( "This action is not available inside the Free Edition.\nPlease look at http://www.editix.com" );
			BrowserCaller.displayURL( "http://www.editix.com" );
			return;
			
		}		

		//
		String title = "Build an XPath 1.0 expression and apply it from the current node or root node. A dialog will appear for non node result";
			
		XPathDialog dialog = new XPathDialog(
			title,
			false, 
			vars, 
			namespaces );
		if ( items != null )
			dialog.setItems( items );					
		dialog.setVisible( true );
		dialog.dispose();
		items = dialog.getItems();
		vars = dialog.getVariablesModel();
		namespaces = dialog.getNamespacesModel();
		//
	}

}
