package com.japisoft.editix.action.xml.refactor;

import com.japisoft.editix.action.xml.format.FormatAction;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.framework.xml.refactor2.AbstractRefactor;
import com.japisoft.framework.xml.refactor2.elements.InsertElement;
import com.japisoft.framework.xml.refactor2.elements.InsertText;
import com.japisoft.framework.xml.refactor2.elements.SurroundElement;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RefactorInsertTextAction extends FormatAction {

	protected boolean isIllegalName( String txt ) {
		if ( "".equals( txt ) )
			return true;
		for ( int i = 0; i < txt.length(); i++ )
			if ( Character.isWhitespace( txt.charAt( i ) ) )
				return true;
		return false;
	}

	protected AbstractRefactor getRefactor() {
		
		XMLContainer container = 
			EditixFrame.THIS.getSelectedContainer();
		FPNode element = container.getCurrentElementNode();
		if ( element == null ) {
			throw new RuntimeException( "No current element" );
		}

		String oldValue = element.getContent();
		String newValue = 
			EditixFactory.buildAndShowInputDialog( "Insert this text" );
		if ( newValue == null ) {
			throw new RuntimeException( "" );
		}
		
		InsertText re = new InsertText();
		re.setOldValue( oldValue );
		re.setNewValue( newValue );

		return re;
	}

}
