package com.japisoft.editix.action.xsl;

import net.sf.saxon.event.PipelineConfiguration;
import net.sf.saxon.event.Receiver;
import net.sf.saxon.om.NamespaceBinding;
import net.sf.saxon.om.NodeName;
import net.sf.saxon.trans.XPathException;
import net.sf.saxon.type.SchemaType;
import net.sf.saxon.type.SimpleType;

// XSLT 2 output message
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSLT2MessageReceiver implements Receiver, MessageReceiver {

	private StringBuffer result = null;
	
	@Override
	public String getSystemId() {
		return null;
	}

	@Override
	public void attribute(NodeName arg0, SimpleType arg1, CharSequence arg2, int arg3, int arg4) throws XPathException {
	}

	@Override
	public void characters(CharSequence arg0, int arg1, int arg2) throws XPathException {
		// if ( storeIt ) {
		if ( result == null )
			result = new StringBuffer();
		if ( result.length() > 0 )
			result.append( "\n" );
		result.append( arg0 );
		// }
	}

	public String getResult() {
		if ( result == null )
			return "";
		return result.toString();
	}
	
	@Override
	public void close() throws XPathException {
	}

	@Override
	public void comment(CharSequence arg0, int arg1, int arg2) throws XPathException {
	}

	@Override
	public void endDocument() throws XPathException {
	}

	@Override
	public void endElement() throws XPathException {
	}

	@Override
	public PipelineConfiguration getPipelineConfiguration() {
		return null;
	}

	@Override
	public void namespace(NamespaceBinding arg0, int arg1) throws XPathException {
	}

	@Override
	public void open() throws XPathException {
		result = new StringBuffer();
	}

	@Override
	public void processingInstruction(String arg0, CharSequence arg1, int arg2, int arg3) throws XPathException {
	}

	@Override
	public void setPipelineConfiguration(PipelineConfiguration arg0) {
	}

	@Override
	public void setSystemId(String arg0) {
	}

	@Override
	public void setUnparsedEntity(String arg0, String arg1, String arg2) throws XPathException {
	}

	@Override
	public void startContent() throws XPathException {
	}

	@Override
	public void startDocument(int arg0) throws XPathException {
		// TODO Auto-generated method stub

	}

	boolean storeIt = false;
	
	@Override
	public void startElement(NodeName arg0, SchemaType arg1, int arg2, int arg3) throws XPathException {
		storeIt = ( "message".equals( arg0.getLocalPart() ) );
	}

	@Override
	public boolean usesTypeAnnotations() {
		// TODO Auto-generated method stub
		return false;
	}

}
