package com.japisoft.editix.db.berkley;

import java.io.File;

import com.japisoft.editix.db.Driver;
import com.japisoft.editix.db.RootNodeDb;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.sleepycat.dbxml.XmlContainer;
import com.sleepycat.dbxml.XmlManager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BerkleyDriver extends Driver {

	public BerkleyDriver( FPNode node ) {
		super( node );
	}	
	
	public RootNodeDb getRoot(String url, String user, String password)
			throws Exception {

		File f = new File( url );
		if ( !f.exists() ) {
			throw new Exception( "Cannot find a container/you may try the 'test' button" );
		}

		BerkleyRootDbImpl root = new BerkleyRootDbImpl( toString(), url );
		
		return root;
	}

	public boolean test(String url, String user, String password) {
		
		File f = new File( url );
		if ( !f.exists() ) {

			if ( EditixFactory.buildAndShowConfirmDialog( "This container doesn't exist, do you want to create it ?" ) ) {
				
				try {
					XmlManager m = new XmlManager();
					try {
						XmlContainer container = m.createContainer( url );
						if ( container != null ) {
							EditixFactory.buildAndShowInformationDialog( "Container created" );
						}
					} finally {
						m.close();
					}
					
				} catch ( Exception e ) {

					EditixFactory.buildAndShowErrorDialog( "Can't build : " + e.getMessage() );
					return false;
					
				}

			}
			
		}
			
		return true;

	}
	
}
