package com.japisoft.editix.db.xmldb;

import com.japisoft.editix.db.AbstractNodeDb;
import com.japisoft.editix.db.ContainerNodeDb;
import com.japisoft.editix.db.FileNodeDb;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XmlDbFileNodeDbImpl extends AbstractNodeDb 
	implements 
		FileNodeDb {

	private String id;
	
	public XmlDbFileNodeDbImpl( ContainerNodeDb parent, String id ) {
		this.parent = parent;
		this.id = id;
	}

	public boolean delete() throws Exception {
		( ( XmlDbContainerDbImpl )getParent() ).delete( id );
		return true;
	}

	public boolean canBeDeleted() {
		return true;
	}
	
	public String getContent() throws Exception {
		return ( ( ContainerNodeDb )getParent() ).getContent( id );
	}

	public void setContent(String content) throws Exception {
		( ( ContainerNodeDb )getParent() ).setContent( id, content );		
	}

	public String toString() {
		return id;
	}

	public void refresh() throws Exception {
	}
}
