package com.japisoft.editix.document.json;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SchemaProperty {

	public String name;
	public String type;
	public String description;
	public boolean required;
	
	public SchemaProperty( String name, String type, String description ) {
		this.name = name;
		this.type = type;
		this.description = description;
	}
	
	public String toString() {
		String r = "\"" + name + "\":";
		if ( "string".equals( type ) )
			r += "\"\"";
		if ( "number".equals( type ) )
			r += "0";
		if ( "integer".equals( type ) )
			r += "0";
		if ( "boolean".equals( type ) ) 
			r += "false";
		if ( "null".equals( type ) )
			r += "null";
		if ( "object".equals( type ) )
			r += "{ }";
		return r;
	}
	
}
