package com.japisoft.editix.editor.jsx.domapi;

import java.util.ArrayList;
import java.util.List;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NodeList {

	private List<Node> nodes = null;
	public int length = 0; 

	public Node item(int index) {
		if ( nodes == null )
			return null;
		if ( index >= nodes.size() || index < 0 )
			return null;
		return nodes.get( index );
	}
	
	public Node addNode( Node node ) {
		if ( nodes == null )
			nodes = new ArrayList<Node>();
		nodes.add( node );
		length = nodes.size();
		return node;
	}
	
	int indexOf( Node node ) {
		if ( nodes == null )
			return -1;
		return nodes.indexOf( node );
	}
	
	void insert( Node parent, int index, Node node ) {
		if ( nodes == null || index >= length ) {
			addNode( node );
			parent.getDOMNode().appendChild( node.getDOMNode() );
		} else
		{
			parent.getDOMNode().insertBefore( node.getDOMNode(), nodes.get( index ).getDOMNode() );
			
			nodes.add( index, node );
			length++;
			

		}
	}
}
