package com.japisoft.editix.editor.xquery.helper;

import java.awt.Color;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.handler.AbstractHelperHandler;
import com.japisoft.xmlpad.helper.model.BasicDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class KeywordsHandler extends AbstractHelperHandler {

	protected void installDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			int offset,
			String activatorString) {

		for ( int i = 0; i < Keywords.main.length; i++ ) {

			String keyword = Keywords.main[ i ];
			BasicDescriptor rd = new BasicDescriptor( keyword );
			rd.setColor( Color.BLUE );
			addDescriptor( rd );

		}

		Color c = Color.MAGENTA.darker();
		
		for ( int i = 0; i < Keywords.axes.length; i++ ) {

			String keyword = Keywords.axes[ i ];
			BasicDescriptor rd = new BasicDescriptor( keyword );
			rd.setComment( "Axis" );
			rd.setColor( c );
			addDescriptor( rd );

		}

		c = Color.GREEN.darker();
		
		for ( int i = 0; i < Keywords.functions.length / 2; i += 2 ) {

			String keyword = Keywords.functions[ i ];
			BasicDescriptor rd = new BasicDescriptor( keyword );
			rd.setComment( "Function :\n" + Keywords.raw_functions[ i / 2 ] );
			rd.setColor( c );
			addDescriptor( rd );

		}

	}

	protected String getActivatorSequence() {
		return null;
	}

	public String getTitle() {
		return "Keywords and Functions";
	}

	public boolean haveDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			boolean insertBefore, 
			int offset,
			String activatorString ) {
		return activatorString == null;
	}

}
