package com.japisoft.editix.editor.xsd.view.element.simpletype;

import javax.swing.JComponent;
import org.w3c.dom.Element;

import com.japisoft.editix.editor.xsd.Changeable;
import com.japisoft.editix.editor.xsd.toolkit.SchemaHelper;
import com.japisoft.editix.editor.xsd.toolkit.XSDAttribute;
import com.japisoft.editix.editor.xsd.view.View;
import com.japisoft.editix.editor.xsd.view.element.PropertiesViewImpl;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ListViewImpl implements View, Changeable {

	private PropertiesViewImpl av = new PropertiesViewImpl() {

		public void init(Element e) {
			initE = e;
			if ( e != null ) {
				contents = new XSDAttribute[] {
						new XSDAttribute( "type (list items)", XSDAttribute.TYPE_REF, null, true )	
				};
				reloadModel();
			} else
				super.init( e );
		}
		
		public void stopEditing() {
			Object value = getEditorValue();
			if ( value != null ) {
				String listType = ( String )value;
				Element parent = SchemaHelper.getFirstChild( initE, "list" );
				if ( parent == null ) {
					parent = SchemaHelper.createElement( initE, "list" );
					initE.appendChild( parent );
				}
				parent.setAttribute( "itemType", listType );
			}
		};
	};
	
	public void init(Element schemaNode) {
		av.init( schemaNode );
	}

	public JComponent getView() {
		return av.getView();
	}

	public void dispose() {
		av.dispose();
	}

	public void stopEditing() {
		av.stopEditing();
	}
	
	@Override
	public boolean isChanged() {
		return av.isChanged();
	}
	
	@Override
	public void copy() {
	}
	@Override
	public void cut() {
	}
	@Override
	public void paste() {
	}

}
