package com.japisoft.editix.editor.xsd.view2.nodeview;

import java.awt.Color;
import java.awt.Graphics2D;

import javax.swing.UIManager;

import org.w3c.dom.Element;

import com.japisoft.editix.editor.xsd.view.View;
import com.japisoft.editix.editor.xsd.view2.node.XSDNode;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class AttributeNodeView extends AbstractXSDNodeView {

	public AttributeNodeView( XSDNode node ) {
		super( node );
	}

	@Override
	protected boolean isOptional() {
		Element e = node.getDOM();
		if ( e.hasAttribute( "use" ) ) {
			if ( "optional".equals( 
					e.getAttribute( "use" ) ) ) {
				return true;
			}
		}
		return false;
	}	
	
	protected void createBuffer( View designer ) {
		
		Graphics2D gc = ( Graphics2D )designer.getView().getGraphics();
		int width = gc.getFontMetrics().stringWidth( "@ " + node.toString() );
		int height = gc.getFontMetrics().getHeight();

		buffer = createBufferedImage(
			width,
			height 
		);

		Graphics2D bgc = ( Graphics2D )buffer.getGraphics();

		if ( node.isSelected() ) {
			bgc.setColor( getSelectionColor() );
		} else {		
			bgc.setColor( getEnabledColor() );
		}

		bgc.fillRoundRect( 0, 0, buffer.getWidth(), buffer.getHeight(), 10, 10 );		

		bgc.setColor( Color.BLACK );
		bgc.setFont( gc.getFont() );
		bgc.drawString( "@ " + node.toString(), hpadding, buffer.getHeight() - vpadding - gc.getFontMetrics().getDescent() );
		
		setBorder( bgc );
		bgc.setColor( BORDER_COLOR );
		bgc.drawRoundRect( 0, 0, buffer.getWidth() - 1, buffer.getHeight() - 1, 10, 10 );
		
		
	}
	
}
