package com.japisoft.editix.main.steps;

import java.awt.Color;

import javax.swing.plaf.ColorUIResource;
import com.jgoodies.looks.plastic.theme.Silver;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditiXPlasticTheme extends Silver {

	// public static Color BACKGROUND_SELECTION = new Color( Integer.parseInt( "333333", 16 ) );
	
	public static Color BACKGROUND_SELECTION = EditiXLookAndFeel.DARK_BLACK;
	
	// ??
	private final ColorUIResource primary2	= new ColorUIResource( EditiXLookAndFeel.LIGHT_BLACK );	
	
	
	// Bordure externe
	private final ColorUIResource primary1	= new ColorUIResource(106,106,106);
	
	// Bouton de scrolling + Ligne arbre
	private final ColorUIResource primary3	= new ColorUIResource(200,200,200);

	// Border externe
	private final ColorUIResource secondary1	= primary1;
	
	// Zone grise + Separateur
	private final ColorUIResource secondary2	= new ColorUIResource(180,180,180);
	// Couleur de fond des panneaux
	private final ColorUIResource secondary3	= new ColorUIResource( Integer.parseInt( "E5E5E5", 16 ) );
	
	// Menu
	private final ColorUIResource menu = new ColorUIResource( 255,255,255 ); 

	@Override
	public ColorUIResource getMenuBackground() {
		return secondary3;
	}

	@Override
	public ColorUIResource getMenuItemSelectedBackground() {
		return primary2;
	}

	@Override
	public ColorUIResource getMenuSelectedBackground() {
		return primary2;
	}

	protected ColorUIResource getPrimary1()		{ return primary1; }
	protected ColorUIResource getPrimary2()		{ return primary2; }
	protected ColorUIResource getPrimary3()		{ return primary3; }

	protected ColorUIResource getSecondary1()		{ return secondary1; }
	protected ColorUIResource getSecondary2()		{ return secondary2; }
	protected ColorUIResource getSecondary3()		{ return secondary3; }
	
	public ColorUIResource getTitleTextColor()	{ return primary1; }
	
	@Override
	public ColorUIResource getFocusColor() {
		return secondary2;
	}	
	
}
