package com.japisoft.editix.toolkit;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.preferences.Preferences;
import com.japisoft.framework.xml.XMLParser;
import com.japisoft.xmlpad.xml.validator.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditiXSAXParserFactory extends XMLPadSAXParserFactory {

	private static final String HTTP_APACHE_ORG_XML_FEATURES_XINCLUDE = "http://apache.org/xml/features/xinclude";

	protected SAXParser getNonStaticNewSAXParser( boolean validating )
		throws ParserConfigurationException, SAXException {
		try {
			SAXParserFactory spf = XMLParser.getSaxParserFactory( validating );
			try {
				if (Preferences.getPreference(
						"xmlconfig", "xinclude", true ))
					spf.setXIncludeAware( true );
			} catch (RuntimeException e) {
			}

			SAXParser sp = spf.newSAXParser();
			return sp;
		} catch( Exception exc ) {
			return super.getNonStaticNewSAXParser( validating );
		}
	}

	protected DocumentBuilderFactory getDocumentBuilderFactory() {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		
		// XInclude features
		
/*		
 * BUG FROM XERCES
 * if ( Preferences.getPreference(
				"xmlconfig", "xinclude", true ) )
		dbf.setXIncludeAware( true ); */
		
		return dbf;
	}

}
