package com.japisoft.editix.ui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import com.japisoft.editix.main.EditixApplicationModel;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.dialog.about.AboutDialog;
import com.japisoft.p3.Manager;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class AboutAction extends AbstractAction {

	public void actionPerformed( ActionEvent e ) {

		DialogManager.resetDefaultSize( new Dimension( 370, 500 ) );

		String message = 
			Manager.hasValidRegisteredFile() ? ( "Registered version by " + Manager.getUser() ) : " 30 Day Evaluation Version ";
		if ( Manager.isFree() )
			message = "Free Edition";

		AboutDialog.showDialog(
			EditixFrame.THIS,
			EditixApplicationModel.LONG_APPNAME,
			EditixApplicationModel.getAppYear(),
			EditixApplicationModel.BUILD,
			"JAPISOFT - Alexandre Brillant",
			"images/logo.png",
			"EditiX is a cross-platform XML & XSL editor",
			message 
		);
	}

}
