package com.japisoft.editix.ui;

import java.awt.BorderLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JFrame;

import com.japisoft.xmlpad.IXMLPanel;
import com.japisoft.xmlpad.XMLContainer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EditixEditorFrame extends JFrame 
		implements WindowListener {
	private IXMLPanel container;

	public EditixEditorFrame( IXMLPanel panel ) {
		this.container = panel;		

		XMLContainer c = panel.getMainContainer();		
		if ( c.getCurrentDocumentLocation() != null )
			setTitle( c.getCurrentDocumentLocation() );
		else
			setTitle( "New document" );
		
		getContentPane().setLayout( new BorderLayout(0,0) );
		getContentPane().add( panel.getView() );
		setSize( 600, 400 );
	}
	
	public void addNotify() {
		super.addNotify();
		addWindowListener( this );
	}

	public void removeNotify() {
		super.removeNotify();
		removeWindowListener( this );
	}

	public XMLContainer getXMLContainer() { return container.getMainContainer(); }

	public IXMLPanel getIXMLPanel() { return container; }
	
	public void windowActivated(WindowEvent e) {
		EditixEditorFrameModel.active( this );
	}

	public void windowClosed(WindowEvent e) {}
	public void windowClosing(WindowEvent e) {
		EditixEditorFrameModel.removeEditixEditorFrame( this );		
		getContentPane().remove( container.getView() );
		EditixFrame.THIS.addContainer( container );
	}
	public void windowDeactivated(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowOpened(WindowEvent e) {
		EditixEditorFrameModel.active( this );
	}

}
