package com.japisoft.editix.ui.panels.project2;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.Map;

import com.japisoft.editix.ui.panels.project2.synchro.Synchronizer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface Project {

	public void load() throws IOException;

	public void save() throws IOException;

	public Node getRoot();
	
	public File getPath();
	
	public boolean contains( File f );
	
	public NodeSortMode getSortMode();

	public boolean skip( String name );

	public void openFile( String path, String type );

	public String getLastType( String path );
	
	public void closeFile( String path, Map properties );

	public Map getProperties( String path );

	public void setSynchronizers( Synchronizer[] synchronizers );
	
	public Synchronizer[] getSynchronizers();
	
	public void setSelectedSynchronized( Synchronizer synchronizer );
	
	public int getSelectedSynchronizer();
	
	public void setNodeState( String[] expandedPath );
	
	public String[] getNodeState();

	public void setEncoding( String path, String encoding );
	
	public String getEncoding( String path );
	
	public void searchFilesForType( List l, String type );
	
}
