package com.japisoft.editix.ui.xflows.actions;

import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;

import com.japisoft.editix.ui.EditixDialog;
import com.japisoft.editix.ui.EditixFactory;
import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.xflows.XFlowsEditor;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.toolkit.Logger;
import com.japisoft.xflows.LoggerModel;
import com.japisoft.xflows.task.Task;
import com.japisoft.xflows.task.TaskLogTable;
import com.japisoft.xflows.task.TaskManager;
import com.japisoft.xmlpad.IXMLPanel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RunAction extends AbstractAction {
	
	public void actionPerformed( ActionEvent e ) {		
		IXMLPanel panel = EditixFrame.THIS.getSelectedPanel();
		
		if ( panel instanceof XFlowsEditor ) {

			XFlowsEditor xe = ( XFlowsEditor )panel;
			List<Task> tasks = xe.getTasks();

			if ( tasks != null ) {
				
				final List<Task> tasks2 = tasks;
				
				EditixDialog ed = new EditixDialog( 
						"XML Scenario", 
						"XML Scenario", 
						"Running " + tasks.size() + " task(s)" 
				);
				ed.getContentPane().add( new JScrollPane( new TaskLogTable() ) );
				ed.setSize( 300, 400 );
				ed.addWindowListener(
					new WindowAdapter() {						
						public void windowOpened(WindowEvent e) {
							TaskManager.run( tasks2, TaskManager.BACKGROUND );			
						};
					}
				);
				ed.setVisible( true );

			} else {
				EditixFactory.buildAndShowWarningDialog( "No task to run ?" );
			}
		} else {
			EditixFactory.buildAndShowWarningDialog( "Can't find a scenario ?" );
		}
	}
	
}
