package com.japisoft.editix.ui.xslt;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;

import javax.swing.text.Document;
import javax.swing.text.JTextComponent;
import javax.swing.text.Highlighter.HighlightPainter;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CurrentHighlighter implements HighlightPainter {

	static Color lineColor = new Color( 150, 220, 150 );
	
	public void paint(Graphics g, int p0, int p1, Shape bounds,
			JTextComponent textComponent) {

		FontMetrics metrics = g.getFontMetrics();
		Document doc = textComponent.getDocument();
		int lineNo = doc.getDefaultRootElement().getElementIndex(p0);

		Rectangle rect = (Rectangle) bounds;
		int height = metrics.getHeight();
		int x = rect.x;
		int y = rect.y + height * lineNo;
		int width = textComponent.getWidth();

		g.setColor(lineColor);
		g.fillRect( x, y, width, height );
		g.draw3DRect( x, y, width, height, true );		

	}
	
	
}
