package com.japisoft.editix.ui.xslt;

import java.awt.Color;

import javax.swing.ImageIcon;

import com.japisoft.xmlpad.bookmark.BookmarkContext;
import com.japisoft.xmlpad.bookmark.BookmarkModel;
import com.japisoft.xmlpad.bookmark.BookmarkPosition;
import com.japisoft.xmlpad.bookmark.DefaultBookmarkContext;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSLTBookmarkContext extends DefaultBookmarkContext {
	
	public XSLTBookmarkContext() {
		super( new ImageIcon( 
				ClassLoader.getSystemResource( "images/breakpoint.png" ) ),
					new Color( 255, 143, 107 ) 
		);
	}

	public XSLTBookmarkContext( XSLTBookmarkContext parent ) {
		this();
		// Marge bookmark location
		merge( parent, null );
	}

	public void merge( BookmarkContext parent, Object source ) {
		if ( parent != null ) {
			BookmarkModel parentModel = 
				parent.getModel();
			BookmarkModel model = getModel();
			for ( int i = 0; i < parentModel.getBookmarkCount(); i++ ) {
				BookmarkPosition position = 
					parentModel.getBookmarkPositionAt( i );
				position.setSource( source );
				model.addBookmarkPosition( position );
			}
		}
	}

}
