package com.japisoft.editix.ui.xslt.debug;

import org.w3c.dom.Node;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DebugElement {
	
	public Node element;
	public int line;
	public boolean resultElement;
	public String uri;
	
	public String elementName;
	
	public DebugElement( Node element, int line, boolean resultElement, String uri ) {
		this.element = element;
		this.line = line;
		this.resultElement = resultElement;
		this.elementName = element.getNodeName();
		this.uri = uri;
	}

	public DebugElement( String element, int line, String uri ) {
		this( element, line, false, uri );
	}

	public DebugElement( String element, int line, boolean resultElement, String uri ) {
		this.elementName = element;
		this.line = line;
		this.resultElement = resultElement;
		this.uri = uri;
	}
	
	public String toString() {
		return elementName;
	}

}
