package com.japisoft.editix.ui.xslt.map;

import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class VirtualDomNodeModel implements TreeModel {

	private VirtualDomNode root;

	public VirtualDomNodeModel( VirtualDomNode root ) {
		this.root = root;
	}

	private TreeModelListener l;
	
	public void addTreeModelListener(TreeModelListener l) {
		this.l = l;
	}

	public Object getChild(Object parent, int index) {
		return ( ( VirtualDomNode )parent ).getChildAt( index );
	}

	public int getChildCount(Object parent) {
		return ( ( VirtualDomNode )parent ).getChildCount();		
	}

	public int getIndexOfChild(Object parent, Object child) {
		return ( ( VirtualDomNode )parent ).getIndexOfChild( ( VirtualDomNode )child );
	}

	public Object getRoot() {
		return root;
	}

	public boolean isLeaf(Object node) {
		return getChildCount( node ) == 0;
	}

	public void removeTreeModelListener(TreeModelListener l) {
		this.l = null;
	}

	public void fireUpdate() {
		this.l.treeStructureChanged( new TreeModelEvent(this, new Object[] { getRoot() } ) );
	}
	
	public void valueForPathChanged(TreePath path, Object newValue) {
	}
	
}
