package com.japisoft.framework;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ApplicationStepException extends RuntimeException {

	private boolean critical = false;
	
	public ApplicationStepException( boolean critical ) {
		super();
		this.critical = critical;
	}
	
	public ApplicationStepException( String message, boolean critical ) {
		super( message );
		this.critical = critical;
	}

	public ApplicationStepException( String message, Throwable cause, boolean critical ) {
		super(message, cause);
		this.critical = critical;
	}

	public ApplicationStepException(Throwable cause, boolean critical) {
		super(cause);
		this.critical = critical;
	}

	/** 
	 * @return <code>true</code> if this error avoid the application to continue
	 */
	public boolean isCritical() {
		return critical;
	}
}
