package com.japisoft.framework.css;

import java.util.ArrayList;
import java.util.List;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BorderParser {

	private static BorderParser INSTANCE = null;
	
	private static List<String> styles = null;
	
	static {
		styles = new ArrayList<String>();
		styles.add( "none" );
		styles.add( "hidden" );
		styles.add( "dotted" );
		styles.add( "dashed" );
		styles.add( "solid" );
		styles.add( "double" );
		styles.add( "groove" );		
		styles.add( "ridge" );
		styles.add( "inset" );
		styles.add( "outset" );
		styles.add( "inherit" );
	}
	
	private BorderParser() {
		INSTANCE = this;
	}
	
	public static BorderParser getInstance() {
		if ( INSTANCE == null )
			new BorderParser();
		return INSTANCE;
	}
	
	public CSSBorder parse( String content ) {
		CSSBorder border = new CSSBorder();
		String[] parts = content.split( " " );
		for ( String part : parts ) {
			part = part.toLowerCase();
			if ( styles.contains( part ) )
				border.setStyle( part );
			else {
				if ( Character.isDigit(
					part.charAt( 0 ) ) ) {
					border.setWidth( new CSSDim( part ) );
				} else
					border.setColor( 
						ColorParser.getInstance().parseColor( part ) 
					);
			}
				
		}
		return border;
	}
	
}
