package com.japisoft.framework.css;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class CSSDim {

	private int value;
	private boolean percent = false;
	
	public static CSSDim ZERO = new CSSDim( 0, false );
	
	public CSSDim( String value ) {
		if ( value.endsWith( "%" ) ) {
			percent = true;
			value = value.substring( 0, value.length() - 1 );
		} else
		if ( value.endsWith( "px" ) ) {
			value = value.substring( 0, value.length() - 2 );
		}
		this.value = Integer.parseInt( value );
	}
	
	public CSSDim( int value, boolean percent ) {
		this.value = value;
		this.percent = percent;
	}

	public int getValue() {
		return value;
	}
	
	public boolean isPercent() {
		return this.percent;
	}
	
	public String toString() {
		return Integer.toString( value ) + ( percent ? "%" : "px" );
	}
	
}
