package com.japisoft.framework.css;

import java.util.List;

import org.w3c.dom.Element;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface Rule {

	public Selector getSelector();
	
	public List<Property> getProperties();
	
	public Property getProperty( String name );

	public void removeProperty( String name );
	
	public boolean match( Element node );	

	public Rule merge( Rule r );
	
	public static Rule EMPTY_RULE = new Rule() {

		public Rule merge(Rule r) {
			return this;
		}
		
		public boolean match(Element node) {
			return false;
		}
		
		public Selector getSelector() {
			return null;
		}
		
		public Property getProperty(String name) {
			return null;
		}
		
		public void removeProperty(String name) {
		}
		
		public List<Property> getProperties() {
			return null;
		}
		
	};

}
