package com.japisoft.framework.css;

import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SimpleParser implements Parser {

	public CSSDocument parse( String baseuri, String uri ) throws Exception {
		URL u = null;
		if ( baseuri == null )
			u = new URL( uri );
		else {
			if ( !baseuri.contains( "://" ) ) {
				baseuri = "file:/" + baseuri;
			}
			u = new URL( new URL( baseuri ), uri );
		}
		String content = getContent( u );
		SimpleCSSDocument doc = new SimpleCSSDocument( content );
		return doc;
	}

	private String getContent( URL u ) throws IOException {
		InputStreamReader r = new InputStreamReader( u.openStream(), "UTF-8" );
		char[] buffer = new char[ 1024 ];
		StringBuffer res = new StringBuffer();
		int c = -1;
		while ( ( c = r.read( buffer ) ) > 0 ) {
			res.append( new String( buffer, 0, c ) );
		}
		return res.toString();
	}

	public static void main( String[] args ) throws Exception {
		SimpleParser p = new SimpleParser();
		CSSDocument doc = p.parse( null, "file:/c:/travail/soft/japisoft-stylededitor/data/Test3.css" );
		Rule r = doc.getRule( "a" );
		Property borderProp = r.getProperty( "border" );
		CSSBorder border = ( CSSBorder )borderProp.getValue();

		String[] dir = new String[] {
			"border-left", "border-right", "border-top", "border-bottom"
		};

		for ( String d: dir ) {
			System.out.println( d + " : " + border.getSide( d ) );
		}
	}

}
