package com.japisoft.framework.dialog;

import java.awt.Component;

import javax.swing.JComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface DialogComponent {

	/** @return the last user action */
	public int getLastAction();

	/** Show or hide the dialog */
	public void setVisible( boolean visible );
	
	public void setVisible( boolean visible, int lastAction );

	public void setModal( boolean modal );

	/**
	 * @param header The header component
	 * @param pane The user component
	 * @param footer The component with the available buttons */
	public DialogComponent init( DialogHeader header, JComponent pane, DialogFooter footer );

	/** Freeing all the resource */
	public void dispose();
	
	/** @return the dialog component */
	public Component getView();
	
}
