package com.japisoft.framework.dialog.error;

import java.io.PrintWriter;
import java.io.StringWriter;
import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ErrorConsole {

	/** Show this exception with information to the user in the error output */
	public static void show( Throwable th ) {
		StringWriter sw = new StringWriter();
		th.printStackTrace(new PrintWriter( sw ) );
		StringBuffer sb = new StringBuffer();
		sb.append( ApplicationModel.getAppNameVersion() );
		sb.append( "\nHas met an unknown error, please send it to : " + ApplicationModel.MAIN_SUPPORT_EMAIL + "\n" );
		sb.append( "specifying your operating system version and java version\n" );
		sb.append( "* Java version : " ).append( System.getProperty( "java.version" ) ).append( "\n" );
		sb.append( "* OS : " ).append( System.getProperty( "os.name" ) ).append( "\n" );		
		sb.append( "\n----------------------------------------------------------------\n\n" );
		sb.append( sw.toString() );
		System.err.println( sb.toString() );		
	}
	
}
