package com.japisoft.framework.dialog.register;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RegisteredPane extends JPanel {

	private String from;
	private String personal;
	private String company;
	private String currency;
	
	public RegisteredPane( String from, String personalPrice, String companyPrice, String currency ) {
		this.from = from;
		this.personal = personalPrice;
		this.company = companyPrice;
		this.currency = currency;
		init();
	}

	JLabel lblUserName = new JLabel();
	JTextField tfUserName = new JTextField();
	JLabel lblKey = new JLabel();
	JTextField tfRegisteredKey = new JTextField();
	JTextArea jTextArea1 = new JTextArea();
	GridBagLayout gridBagLayout1 = new GridBagLayout();

	private void init() {
		lblUserName.setText("Registered name");
		setLayout(gridBagLayout1);
		tfUserName.setText("");
		lblKey.setText("Registered key");
		tfRegisteredKey.setText("");
		add(
			lblUserName,
			new GridBagConstraints(
				0,
				0,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.WEST,
				GridBagConstraints.NONE,
				new Insets(6, 7, 0, 268),
				10,
				0));
		add(
			tfUserName,
			new GridBagConstraints(
				0,
				1,
				1,
				1,
				1.0,
				0.0,
				GridBagConstraints.WEST,
				GridBagConstraints.HORIZONTAL,
				new Insets(0, 7, 0, 11),
				329,
				0));
		add(
			lblKey,
			new GridBagConstraints(
				0,
				2,
				1,
				1,
				0.0,
				0.0,
				GridBagConstraints.WEST,
				GridBagConstraints.NONE,
				new Insets(9, 7, 0, 225),
				27,
				0));
		add(
			tfRegisteredKey,
			new GridBagConstraints(
				0,
				3,
				1,
				1,
				1.0,
				0.0,
				GridBagConstraints.WEST,
				GridBagConstraints.HORIZONTAL,
				new Insets(7, 7, 0, 11),
				329,
				0));
		add(
			jTextArea1,
			new GridBagConstraints(
				0,
				4,
				1,
				1,
				1.0,
				1.0,
				GridBagConstraints.CENTER,
				GridBagConstraints.BOTH,
				new Insets(18, 7, 8, 11),
				91,
				48));
		jTextArea1.setEditable(false);
		jTextArea1.setText(
			"Please order at : " + from + "\n\n" + ( ( personal != null ) ? ( "- Personal single user license for $" + personal ) : "" ) + "\n- Company single user license for $" + company + "...\n\nAll prices are in " + currency );
	}

	public String getUser() { return tfUserName.getText(); }

	public String getKey() { return tfRegisteredKey.getText(); } 
}
