package com.japisoft.framework.dialog.report;

import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RequestReportingAction extends BugReportingAction {

	/**
	 * @param url remote server for storing user request */
	public RequestReportingAction( String url ) {
		super( url );

		dialogTitle = "Feature request";
		type = "SUG";
		userInformation = "Insert a request in the field below, this interface will include automatically your release and operating system. The title is required. If you wish to receive a reply, please insert your email. Note that you MUST have an active internet connection for using this form.";		
		image = "images/help2.png";		

	}

	public RequestReportingAction() {
		this( ApplicationModel.REPORTING_URL );
	}

}
