package com.japisoft.framework.dockable;

import java.util.ArrayList;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DockManager {

	static ArrayList dockedFrameList = new ArrayList();
	
	static void storeDefaultDockedFrame( DefaultDockedFrame frame ) {
		if ( dockedFrameList == null )
			dockedFrameList = new ArrayList();
		dockedFrameList.add( frame );
	}
	
	static void unstoreDefaultDockedFrame( DefaultDockedFrame frame ) {
		if ( dockedFrameList != null )
			dockedFrameList.remove( frame );
	}
	
	/** It will "undock" all DockedPanel thus, no external frame will be visible */
	public static void removeAllDockedFrame() {
		if ( dockedFrameList != null ) {
			
			Object[] snap = dockedFrameList.toArray();
			for ( int i = 0; i < snap.length; i++ ) {
				( ( DefaultDockedFrame )snap[ i ] ).undock();
			}
		}
		
		dockedFrameList = null;
	}
	
	static DockableFrameTitleBar LAST_FOCUS = null;
}
