package com.japisoft.framework.dockable;

import java.awt.Color;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface DockableFrameTitleBar {

	/** @return the dockableFrame title */
	public String getTitle();

	/** Update the title */
	public void setTitle( String title );

	/** @return an icon for this title bar */
	public Icon getIcon();
	
	/** Update the icon */
	public void setIcon( Icon icon );
	
	/** Add a new button for acting on the DockableFrame */
	public void addButton( JButton button );

	/** Add a separator for the buttons */
	public void addSeparator();

	/** Remove all buttons */
	public void removeAllButtons();

	/** Prepare the title bar component to be shown once all buttons have been added */
	public void prepare();

	/** @return the view of the title bar. This is the final component */
	public JComponent getView();

	/** Reset the focus for this titled bar */
	public void focusMode( boolean focused );

	/** Reset the color for the background header. Use a <code>null</code>
	 * value for restoring the initial value */	
	public void setBackground( Color color );

	/** Update the foreground color. Use a <code>null</code>
	 * value for restoring the initial value */
	public void setForeground( Color color );

}
