package com.japisoft.framework.internationalization;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.HashMap;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Traductor {

	private HashMap traduction = null;
	
	private Traductor() {
		traduction = 
			new HashMap();
	}

	private static Traductor currentTraductor = null;
	
	public static void setTraductor( String language ) {
		currentTraductor = 
			new Traductor();
		currentTraductor.read( language.toLowerCase() );
	}

	public static String traduce( String code, String def ) {
		if ( currentTraductor == null || 
				code == null )
			return def;
		String tmp = ( String )currentTraductor.traduction.get( code );
		if ( tmp == null )
			return def;
		return tmp;
	}

	private void read( String language ) {
		URL u = 
			Traductor.class.getResource( 
				"traduction_" + language + ".txt" );
		if ( u == null ) {
			// Try to load the default one
			language = "en";
			u =
				Traductor.class.getResource( 
					"traduction_" + language + ".txt" );
		}
		if ( u != null ) {
			try {
				InputStream input = 
					u.openStream();
				BufferedReader br = 
					new BufferedReader( 
						new InputStreamReader( 
							input ) );
				try {
					String l = null;
					while ( ( l = br.readLine() ) != null ) {
						int i = l.lastIndexOf( "=" );
						if ( i > -1 ) {
							traduction.put( 
								l.substring( 0, i ),
								l.substring( i + 1 )
							);
						}
					}
				} finally {
					br.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

}
