package com.japisoft.framework.spreadsheet2.xls;

import java.util.ArrayList;
import java.util.List;

import com.japisoft.framework.spreadsheet2.Row;
import com.japisoft.framework.spreadsheet2.Sheet;
import com.japisoft.framework.spreadsheet2.SpreadSheetConf;
import com.japisoft.framework.spreadsheet2.xls.XLSRow;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XLSSheet implements Sheet {

	private String name;
	
	XLSSheet( SpreadSheetConf conf, org.apache.poi.ss.usermodel.Sheet s  ) {
		name = s.getSheetName();
		for ( int i = 0; i <= s.getLastRowNum(); i++ ) {
			org.apache.poi.ss.usermodel.Row r = s.getRow( i );
			addRow( r );
		}
	}
		
	private List<XLSRow> rows = null; 
			
	private void addRow( org.apache.poi.ss.usermodel.Row r ) {
		if ( rows == null )
			rows = new ArrayList<XLSRow>();
		rows.add( new XLSRow( r ) );
	}
	
	@Override
	public int getRowCount() {
		if ( rows == null )
			return 0;
		return rows.size();
	}
	
	@Override
	public Row getRow(int index) {
		return rows.get( index - 1 );
	}
	
	@Override
	public String getName() {
		return name;
	}
	
}
