package com.japisoft.framework.step;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.framework.ApplicationStepAdapter;
import com.japisoft.framework.ApplicationStepException;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ClassInstanceStep extends ApplicationStepAdapter {
	
	private boolean macMode = false;
	private String className = null;
	
	/** A class name for building the object */
	public ClassInstanceStep( String className ) {
		this.className = className;
	}

	/** A class name for building the object.
	 * @param className A class name
	 * @param forMacOSXOnly decide to use it only for Mac OS X
	 */
	public ClassInstanceStep( String className, boolean forMacOSXOnly ) {
		this( className );
		this.macMode = forMacOSXOnly;
	}

	public void start(String[] args) {
		try {
			if ( !macMode || ApplicationModel.MACOSX_MODE ) {
				Class.forName( className ).newInstance();
			}
		} catch (InstantiationException e) {
			throw new ApplicationStepException( e, true );
		} catch (IllegalAccessException e) {
			throw new ApplicationStepException( e, true );
		} catch (ClassNotFoundException e) {
			throw new ApplicationStepException( e, true );
		}	
	}

}
