package com.japisoft.framework.toolkit;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BatchGenerator {
	
	public void createBatch( File dir, String output, String mainClass ) throws Throwable {
		File lib = new File( dir, "lib" );

		BufferedWriter bw = new BufferedWriter(
				new FileWriter( output + ".bat" ) );
		try {
			String[] strl = lib.list();
			bw.write( "set R=../lib" );
			bw.newLine();
			bw.write( "set CP=../res" );
			bw.newLine();
			for ( int i = 0; i < strl.length; i++ ) {
				if ( strl[ i ].endsWith( "jar" ) ) { 
					bw.write(
						"set CP=%CP%;%R%/" + strl[ i ] );
					bw.newLine();
				}
			}
			bw.write( "java -classpath %CP% -Xms64m -Xmx512m " + mainClass + " %1" );
		} finally {
			bw.close();
		}
		
		bw = new BufferedWriter(
				new FileWriter( output + ".sh" ) );
		try {
			String[] strl = lib.list();
			bw.write( "CP=../res" );
			for ( int i = 0; i < strl.length; i++ ) {
				if ( strl[ i ].endsWith( "jar" ) ) { 
					bw.write(
						":../lib/" + strl[ i ] );
					System.out.println( "<string>$JAVAROOT/" + strl[ i ] + "</string>" );					
				}
			}
			bw.newLine();			
			bw.write( "java -classpath $CP -Xms64m -Xmx512m " + mainClass + " $1" );
		} finally {
			bw.close();
		}		


		
		
	}

	public static void main( String[] args ) throws Throwable {				
		BatchGenerator bg = new BatchGenerator();
		
		bg.createBatch( 
				new File( "C:/travail/soft/xflows/distrib/install-content" ),
				"C:/travail/soft/xflows/distrib/install-content/bin/run",
				"com.japisoft.xflows.Main" );
				
		
/*		
 
 		if ( args == null || args.length == 0 ) {
			System.out.println( "[output dir] [main class]");
			System.exit( 1 );
		}
 
		bg.createBatch(
				new File( System.getProperty( "user.dir") ),
				args[ 0 ],
				args[ 1 ] ); */
	}

}
