package com.japisoft.framework.ui;

import java.awt.BorderLayout;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;

import com.japisoft.framework.ApplicationMain;
import com.japisoft.framework.ui.layout.ButtonLayout;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class GradientPanel extends JPanel {


	
	
	private GradientLabel lbl = new GradientLabel();

	public GradientPanel( String defaultTitle, JComponent target ) {
		setLayout( new BorderLayout() );
		lbl.setTitle( defaultTitle );
		add( lbl, BorderLayout.NORTH );
		add( target );
	}

	
	/** Add buttons to the gradient label */
	public void addButtons( JButton[] btns ) {
		lbl.setLayout( new ButtonLayout() );
		for ( int i = 0; i < btns.length; i++ )
			lbl.add( btns[ i ] );
	}

	public void updateTitle( String title ) {
		lbl.setTitle( title );
	}
}
