package com.japisoft.framework.ui;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Window;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Toolkit {

	public static void center( Window frame ) {
		Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation(
				( screen.width - frame.getWidth() ) / 2,
				( screen.height - frame.getHeight() ) / 2 );
	}

	public static void mapper( HashMap state, Container container ) {
		Iterator keys = state.keySet().iterator();
		while (keys.hasNext()) {
			String name = (String) keys.next();
			Object value = state.get(name);
									
			for (int i = 0; i < container.getComponentCount(); i++) {
				Component c = container.getComponent( i );				
				if ( name.equals( c.getName() ) ) {
					if (c instanceof JLabel) {
						JLabel l = (JLabel) c;
						if (value instanceof Icon) {
							l.setIcon( ( Icon ) value );							
						} else
							l.setText( value.toString() );
					}
				}
				if ( c instanceof Container && ( ( Container )c ).getComponentCount() > 0 )
					mapper( state, ( Container )c );
			}
		}
	}

	public static Icon getIconFromClasspath( String path ) {
		URL url = ClassLoader.getSystemResource( path );
		if ( url == null ) {
			System.err.println( "Can't find " + path );
			return null;
		}
		return new ImageIcon( url ); 
	}

}
