package com.japisoft.framework.ui.table;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.EventObject;

import javax.swing.AbstractCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.event.CellEditorListener;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BooleanTableCellEditor extends AbstractCellEditor implements
		ActionListener, TableCellEditor {

	private TableModel model;
	private JCheckBox cb = new JCheckBox();
	
	public BooleanTableCellEditor( TableModel model ) {
		this.model = model;
		cb.setHorizontalAlignment( SwingConstants.CENTER );
	}

	public void addCellEditorListener( CellEditorListener l ) {
		super.addCellEditorListener( l );
		cb.addActionListener( this );
	}

	public void removeCellEditorListener( CellEditorListener l ) {
		super.removeCellEditorListener( l );
		cb.removeActionListener( this );
	}

	public Object getCellEditorValue() {
		return new Boolean( cb.isSelected() );
	}

	public boolean isCellEditable( EventObject e ) {
		return true;
	}

	private int lastEditedRow = -1;

	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int row, int column) {
		cb.setSelected( ( ( Boolean ) value ).booleanValue() );
		lastEditedRow = row;
		return cb;
	}

	public void actionPerformed(ActionEvent e) {
		model.setValueAt( getCellEditorValue(), lastEditedRow, 1 );
	}

}
