package com.japisoft.framework.xml.format;

import com.japisoft.framework.preferences.Preferences;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FormatterConfig {

	private boolean replaceAPos;
	private boolean replaceAmp;
	private boolean replaceGt;
	private boolean replaceLt;
	private boolean replaceQuote;
	private int formatSpaceQty;
	private String formatSpaceChr = "\t";
	private boolean indentProcessingInstruction = true;
	private boolean autoCloseElement = true;
	private boolean indentElement = true;
	private boolean trimedText = false;
	
	public FormatterConfig() {
		replaceAPos = 
			Preferences.getPreference(
					"xmlconfig", "format-replaceAPos", false );
		replaceQuote = 
			Preferences.getPreference(
					"xmlconfig", "format-replaceQuote", true );
		replaceGt = 
			Preferences.getPreference(
					"xmlconfig", "format-replaceGt", true );
		replaceLt = 
			Preferences.getPreference(
					"xmlconfig", "format-replaceLt", true );
		replaceAmp = 
			Preferences.getPreference(
					"xmlconfig", "format-replaceAmp", true );

		formatSpaceQty = 
			Preferences.getPreference(
					"xmlconfig", "format-space", 1 );
		indentProcessingInstruction =
			Preferences.getPreference(
					"xmlconfig", "format-processingInstruction", true );
	}

	public void setAutoCloseElement(boolean autoCloseElement) {
		this.autoCloseElement = autoCloseElement;
	}

	public void setIndentElement(boolean indentElement) {
		this.indentElement = indentElement;
	}

	public void setTrimedText( boolean trim ) {
		this.trimedText = trim;
	}

	public boolean isTrimedText() { return trimedText; }
	public boolean isReplaceAPos() { return replaceAPos; }
	public boolean isReplaceAmp() { return replaceAmp; }
	public boolean isReplaceGt() { return replaceGt; }
	public boolean isReplaceLt() { return replaceLt; }
	public boolean isReplaceQuote() { return replaceQuote; }
	public int getFormatSpaceQty() { return formatSpaceQty; }
	public String getFormatSpaceChr() { return formatSpaceChr; }
	public boolean isIndentProcessingInstruction() { return indentProcessingInstruction; }
	public boolean isAutoCloseElement() { return autoCloseElement; }
	public boolean isIndent() { return indentElement; }
	public boolean isXMLSpace() { return Preferences.getPreference( "xmlconfig", "format-xml:space", true ); }
	
}
