package com.japisoft.framework.xml.grammar.xsd;

import com.japisoft.framework.xml.grammar.Grammar;
import com.japisoft.framework.xml.grammar.GrammarText;
import com.japisoft.framework.xml.grammar.GrammarType;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XSDGrammarText implements GrammarText {

	public XSDGrammarText( XSDGrammar grammar, String value ) {
		this.value = value;
	}

	public Grammar getGrammar() {
		return null;
	}	
	
	public String infer() {
		return "";
	}	

	public XSDGrammarText( String value, GrammarType type ) {
		this.value = value;
		this.type = type;
	}
		
	private String value;
	private GrammarType type = null;
	
	public String getValue() {
		return value;
	}

	public String getName() { 
		return "#text"; }

	public String getNamespace() { 
		return null; }

	public int getMaxOccurs() {
		return 1;
	}
	
	public int getMinOccurs() {
		return 1;
	}

	public GrammarType getType() {
		if ( type == null )
			type = new XSDGrammarType( "string" );
		return type;
	}

}
