package com.japisoft.framework.xml.parser.node;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class NodeFactoryImpl implements NodeFactory {
	
	private NodeFactoryImpl() {
		super();
		THIS = this;
	}

	static NodeFactoryImpl THIS;
	
	public static NodeFactory getInstance() {
		if ( THIS == null )
			new NodeFactoryImpl();
		return THIS;
	}
	
	private static NodeFactory instance;

	/** @return a single instance of the node factory */
	public static NodeFactory getFactory() {
		if (instance == null)
			instance = new NodeFactoryImpl();
		return instance;
	}

	/** @return a text node */
	public FPNode getTextNode(String text) {
		FPNode node = new FPNode(FPNode.TEXT_NODE, text);
		return node;
	}

	/** @return a tag node */
	public FPNode getTagNode(String tag) {
		FPNode node = new FPNode(FPNode.TAG_NODE, tag);
		return node;
	}

	public FPNode getTagNode( int tag ) {
		FPNode node = new FPNode(FPNode.TAG_NODE, tag);
		return node;
	}

	/** @return a comment node */
	public FPNode getCommentNode(String comment) {
		FPNode node = new FPNode(FPNode.COMMENT_NODE, comment);
		return node;
	}

}

// NodeFactory ends here
