package com.japisoft.framework.xml.parser.node;

import java.util.Iterator;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface ViewableNode {
    /** @return nameSpace prefix support */
    public Iterator<String> getNameSpaceDeclaration();
    /** @return a nameSpace declaration URI for this prefix */
    public String getNameSpaceDeclarationURI( String prefix );
    /** @return the current nameSpace prefix */
    public String getNameSpacePrefix();
    /** @return the current nameSpace URI */
    public String getNameSpaceURI();
    /** @return the Default namespace */
    public String getDefaultNamespace();
    /** @return the attribute value for the name or null */
    public String getViewAttributeAt( int index );
    public String getViewAttribute(String name);
    public int getViewAttributeCount();
    /** @return the content of the node */
    public String getViewContent();
    /** @return true is the node is a leaf */
    public boolean isViewLeaf();
    /** @return the child count */
    public int getViewChildCount();
    /** @return a child starting from 0 */
    public ViewableNode getViewChildAt( int i );
    /** @return true for text node */
    public boolean isViewText();
    /** @return true for comment */
    public boolean isViewComment();
    /** @return the stopping line for this node */
    public int getStoppingLine();
    /** @return the starting line for this node */
    public int getStartingLine();
    /** @return the current stopping offset */
    public int getStoppingOffset();
    /** @return the current starting offset */
    public int getStartingOffset();
}

// ViewableNode ends here
