package com.japisoft.framework.xml.parser.tools;

import java.lang.reflect.Field;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import com.japisoft.framework.xml.parser.Messages;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ParserToolkit {
	
	/** It will translate all error messages from the parser using this
	 * bundle. Key for the bundle must match the variable name for the 
	 * <code>Messages</code> class.
	 * @param bundle A set of key/value for a language
	 */
	public static void translateMessages( ResourceBundle bundle ) {
		Field[] fs = Messages.class.getFields();
		for ( int i = 0; i < fs.length; i++ ) {
			String name = fs[ i ].getName();
			try {
				String value = bundle.getString( name );
				fs[ i ].set( null, value );
			} catch( MissingResourceException exc ) {
				if ("true".equals(System.getProperty("fp.debug")))
					System.out.print( "warning cannot traduce " + name );
			} catch( IllegalAccessException exc2 ) {
				exc2.printStackTrace();
				break;
			}
						
		}
		
	}
	
}
