package com.japisoft.framework.xml.refactor.elements;

import org.w3c.dom.Node;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.framework.xml.refactor.ui.RefactorTable;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public abstract class AbstractRefactor implements RefactorObj {
	private RefactorAction ra;
	private short type;
	public static short ANY = -1;

	public AbstractRefactor(short type) {
		this.type = type;
	}

	public Node refactor(Node node) {
		if (node.getNodeType() == type || type == ANY) {
			return refactorIt(node, ra);
		}
		return node;
	}

	public boolean isDefault() { 
		return true; 
	}

	public Node preRefactor(Node node) {
		if (node.getNodeType() == type || type == ANY) {
			return preRefactorIt(node, ra);
		}
		return node;
	}

	abstract protected Node refactorIt(Node node, RefactorAction ra);

	protected Node preRefactorIt(Node node, RefactorAction ra) {
		return node;
	}

	public void initTable( RefactorTable table, FPNode context ) {}	
	
	// ----------------------------------------

	public void setRefactorAction(RefactorAction ra) {
		this.ra = ra;
	}

	public String toString() {
		return getName();
	}
	
	public void stop() {
	}	
}
