package com.japisoft.multipanes;

import java.util.ArrayList;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultTitledPaneModel implements TitledPaneModel {

	private ArrayList model;
	private MultiPanes panes;
	
	public DefaultTitledPaneModel( MultiPanes panes ) {
		this.panes = panes;
		model = new ArrayList();
	}

	public void addTitledPane( TitledPane tp ) {
		model.add( tp );
		panes.updateView();
	}
	
	public void insertTitledPane( int location, TitledPane tp ) {
		model.add( location, tp );
		panes.updateView();
	}

	public void removeTitledPane( TitledPane tp ) {
		model.remove( tp );
		tp.dispose();
		panes.updateView();
	}

	public int getTitledPaneIndex(TitledPane tp) {
		return model.indexOf( tp );
	}	
	
	public TitledPane getTitledPaneByName(String name) {
		if ( name == null )
			throw new RuntimeException( "Illegal null name" );
		for ( int i = 0; i < model.size(); i++ ) {
			TitledPane tp = ( TitledPane )model.get( i );
			if ( name.equals( tp.getName() ) )
				return tp;
		}
		return null;
	}

	public TitledPane getTitledPaneAt(int index) {
		if ( index >= model.size() )
			return null;
		return ( TitledPane )model.get( index );
	}

	public int getTitledPaneCount() {
		return model.size();
	}

}
