package com.japisoft.multipanes;

import java.awt.Color;
import java.beans.PropertyChangeListener;

import javax.swing.Icon;
import javax.swing.JComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface TitledPane {

	/** @return the main title of the panel. It can't be <code>null</code> */
	public String getTitle();
	
	/** @return an icon for the panel, it can be <code>null</code> */
	public Icon getIcon();
	
	/** @return a toolTip for the panel header, it can be <code>null</code> */
	public String getToolTip();

	/** @return a name for this panel */
	public String getName();
	
	/** @return the panel content */
	public JComponent getView();
	
	/** Called when the titledPane is opened by the user */
	public void open();
	
	/** Called when the titlePanel is closed by the user */
	public void close();

	/** Enabled / Disabled */
	public boolean isEnabled();
	
	/** The titlePane has been removed from the multipanes */
	public void dispose();

	/** @return a color for the titled pane background. */
	public Color getBackground();

	/** @return a color for the titled pane foreground */
	public Color getForeground();

	/** Listener about the user interface properties like title, icon or tooltip
	 *  properties name is binded on the swing Action.key */
	public void addPropertyChangeListener(PropertyChangeListener listener);

}
