package com.japisoft.p3;

import java.math.BigInteger;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Checker {

	// Public key

	private static String N = "8907416837986794317725654963193175741438188506163610741638214116740051863723078302281700506066878018041136973667531599112548220215330486280426333257642291";

	private static String E = "58021664585639791181184025950440248398226136069516938232493687505822471836536824298822733710342250697739996825938232641940670857624514103125986134050997697160127301547995788468137887651823707102007839";

	static boolean personal = false;
	static boolean professional = false;
	static boolean student = false;
	static boolean enterprise = false;
	static boolean floating = false;
	static boolean noncommercial = false;
	
	static String check(
			String regname, 
			String key, 
			String persControl, 
			String profControl, 
			String studControl, 
			String enterpriseControl,
			String floatingControl,
			String noncommercialControl ) {

		try {

			BigInteger d = new BigInteger(E);
			BigInteger n = new BigInteger(N);
			if ( key == null || 
					key.length() == 0 )
				return null;

			BigInteger message = new BigInteger(key);
			BigInteger r = message.modPow(d, n);
			String res = new String(r.toByteArray(), "UTF8" );
			personal = (res.endsWith( persControl ));
			professional = (res.endsWith( profControl ));

			student = (res.endsWith( studControl ));
			enterprise = (res.endsWith( enterpriseControl ));
			
			noncommercial = (res.endsWith( noncommercialControl ) );
			
			if ( floatingControl != null )
				floating = (res.endsWith(floatingControl));
			
			if ( !personal && 
					!professional && 
						!student && 
							!enterprise && 
								!floating &&
									!noncommercial ) {
				return null;
			}

			if ( personal )
				return res.substring( 0, res.length() - persControl.length() );
			if ( professional )
				return res.substring( 0, res.length() - profControl.length() );
			if ( student )
				return res.substring( 0, res.length() - studControl.length() );
			if ( floating )
				return res.substring( 0, res.length() - floatingControl.length() );
			if ( noncommercial )
				return res.substring( 0, res.length() - noncommercialControl.length() );
			
			return res.substring( 0, res.length() - enterpriseControl.length() );

		} catch (Throwable th) {
			return null;
		}
	}

	public static void main( String[] args ) throws Exception {
		
	}
	
	
}
