package com.japisoft.p3;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

import com.japisoft.framework.ApplicationModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class RemoteController implements Runnable {

	public static void checkUser( String url, String userName, HackerController controller ) {
		RemoteController runner = new RemoteController();
		runner.controller = controller;
		runner.userName = userName;
		runner.url = url;
		Thread th = new Thread( runner );
		th.start();
	}

	private HackerController controller;
	private String url;
	private String userName;
	
	public void run() {

		try {

			try {
				Thread.sleep( 120000 );
			} catch ( InterruptedException e1 ) {
			}			

			if ( controller == null ) {
				throw new RuntimeException( "Controller expected !" );
			}
			
			URL _url = new URL( url );

			URLConnection connection = _url.openConnection();
			connection.setDoOutput( true );
			connection.setDoInput( true );

			String data = URLEncoder.encode( "version", "UTF-8" ) + "=" + URLEncoder.encode( ApplicationModel.getAppVersion(), "UTF-8" );
			data += "&" + URLEncoder.encode( "os", "UTF-8" ) + "=" + URLEncoder.encode( System.getProperty( "os.name" ), "UTF-8" );
			data += "&" + URLEncoder.encode( "user", "UTF-8" ) + "=" + URLEncoder.encode( userName, "UTF-8" ); 

			OutputStreamWriter wr = new OutputStreamWriter( connection.getOutputStream() );
			wr.write( data );
			wr.flush();
			
			InputStreamReader reader = new InputStreamReader( connection.getInputStream() );
			BufferedReader buffered = new BufferedReader( reader );
			String line = null;
			line = buffered.readLine();

			buffered.close();
			wr.close();
			
			if ( "HA".equals( line ) ) {
				controller.notifyHackerDetected();
			}
		} catch (MalformedURLException e) {
		//	ApplicationModel.debug( e );
		} catch (UnsupportedEncodingException e) {
		//	ApplicationModel.debug( e );
		} catch (IOException e) {
		//	ApplicationModel.debug( e );
		}
	}
	
}

