package com.japisoft.sc;

import java.io.*;
import java.util.Hashtable;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SyntaxFileMapper {
  private ScEditorKit sc;

  public SyntaxFileMapper( ScEditorKit sc ) {
    super();
    this.sc = sc;
  }

  private Hashtable htDescriptor;

  /** Add a relation between a file format and a syntax descriptor */
  public void addRelation( String fileExtension, String propertyId ) {
    if ( htDescriptor == null )
      htDescriptor = new Hashtable();
    htDescriptor.put( fileExtension.toLowerCase(), propertyId );
  }

  /** Update the editor kit for supporting this file format */
  public void resetSyntaxColor( File f ) throws FileNotFoundException {
    resetSyntaxColor( f.toString() );
  }
  /** Update the editor kit for supporting this file format */
  public void resetSyntaxColor( String f ) throws FileNotFoundException {
    if ( htDescriptor != null ) {
      int i = f.lastIndexOf( "." );
      if ( i > -1 ) {
        String ext = f.substring( i + 1 );
        String propertyId = ( String )htDescriptor.get( ext.toLowerCase() );
        if ( propertyId != null ) {
          sc.readSyntaxColorDescriptor( propertyId );
        }
      }
    }
  }

}
