package com.japisoft.stylededitor.model;

import javax.swing.text.Document;
import org.w3c.dom.Text;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TextElement extends BasicNodeElement {

	public TextElement(
			Document document, 
			Text node, 
			int startOffset ) {
		super( 
			document, 
			node, 
			startOffset );
		setEndOffset( 
				getStartOffset() + 
					( node.getNodeValue().length() )
		);
	}

	@Override
	public String getName() {
		return getNode().getNodeValue();
	}
	
	public void setName( String newName ) {
		getNode().setNodeValue( newName );
	}
	
	public int getLength() {
		return getNode().getNodeValue().length();
	}
	
	public char getChar( int index ) {
		return getName().charAt( index );
	}
	
	public void deleteChar( int index ) {
		Text t = ( Text )getNode();
		if ( index == t.getLength() ) {
			if ( t.getNextSibling() instanceof Text ) {
				t.setNodeValue( t.getNodeValue() + t.getNextSibling().getNodeValue() );
				setEndOffset( getEndOffset() + t.getNextSibling().getNodeValue().length() );
				t.getParentNode().removeChild(t.getNextSibling());
			}
		} else {
			if ( index < t.getLength() )
				t.deleteData( index, 1 );
		}
	}

}
