package com.japisoft.xflows.task;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

import com.japisoft.framework.toolkit.LoggerListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class LoggerListenerFileProducer {

	public LoggerListenerFileProducer( File logFile, LoggerListener listener ) {
		try {
			BufferedReader reader = new BufferedReader( new FileReader( logFile ) );
			try {
				String line = null;
				
				// Read at reverse
				ArrayList l = new ArrayList();
				while ( ( line = reader.readLine() ) != null ) {
					l.add( line );
				}
				
				Collections.reverse( l );

				for ( int i = 0; i < l.size(); i++ ) {
					line = ( String )l.get( i );
					if ( line.startsWith( "**" ) ) {
						listener.addError( line.substring( 2 ) );
					} else
					if ( line.startsWith( "*" ) ) {
						listener.addWarning( line.substring( 1 ) );
					} else {
						listener.addInfo( line );
					}
				}
			} finally {
				reader.close();
			}
		} catch( IOException exc ) {
			listener.addError( exc.getMessage() );
		}
	}

}
