package com.japisoft.xflows.task.copy;

import com.japisoft.editix.ui.EditixFrame;
import com.japisoft.editix.ui.panels.universalbrowser.FTPChooserPanel;
import com.japisoft.editix.ui.panels.universalbrowser.FTPConfig;
import com.japisoft.framework.dialog.DialogManager;
import com.japisoft.framework.ui.text.FileTextField;
import com.japisoft.framework.ui.text.FileTextFieldHandler;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class FTPFileTextFieldHandler implements FileTextFieldHandler {

	public static final String HOST = "ftphost";
	public static final String PASSWORD = "ftppassword";
	public static final String USER = "ftpuser";

	public String selectResource(
			FileTextField source,
			String previousPath,
			boolean directoryMode,
			boolean fileMode,
			boolean openedMode,
			String[] fileExt,
			String currentDir ) {
		
		FTPChooserPanel fcp = new FTPChooserPanel();
		if ( DialogManager.showDialog( 
				EditixFrame.THIS, 
				"FTP Configuration", 
				"FTP Configuration", 
				"Choose your FTP parameters", 
				null, 
				fcp 
		) == DialogManager.OK_ID ) {
			FTPConfig config = fcp.getFTPConfig();
			String tmp = config.host;
			if ( config.user != null ) {
				tmp = config.user + ":" + config.password + "@" + tmp;
			}
			if ( config.directory != null )
				tmp = tmp + "/" + config.directory;
			return "ftp://" + tmp;
		}

		return null;
	}

	public void createResource( String path ) {
	}

	public void deleteResource( String path ) {
	}

	public boolean isCreateResourceManaged() {
		return false;
	}
	
	public boolean isDeleteResourceManaged() {
		return false;
	}	
	
}
