package com.japisoft.xflows.task.jsx;

import java.io.File;

import com.japisoft.xflows.task.FilesTaskRunner;
import com.japisoft.xflows.task.TaskContext;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class JSXRunner extends FilesTaskRunner {


	public JSXRunner() {
		super( new JSXTFileRunner(), false );
	}

	public boolean run( TaskContext context ) {
		
		String sourcePath = context.getParam( SOURCEPATH );
		
		
		String jsx = context.getParam( JSXUI.JSX );
		if ( jsx == null ) {
			context.addError( "No JavaScript (JSX) file ?" );
			return ERROR;
		} else {
			
			if ( jsx.indexOf( "://" ) == -1 ) {
				File fstylesheet = new File( jsx );
				if ( !fstylesheet.exists() ) {
					context.addError( "JavaScript (JSX) " + fstylesheet + " not found ");
					return ERROR;
				}
			}
			
			super.run( context );
		}

		return OK;
	}

}
