package com.japisoft.xmlform;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Toolkit {

	public static boolean areRelativeURI( String uri1, String uri2 ) {
		if ( uri1 == null )
			return false;
		if ( uri2 == null )
			return false;
		int i1 = 
			uri1.lastIndexOf( "/" );
		if ( i1 == -1 )
			i1 = uri1.lastIndexOf( "\\" );
		int i2 = 
			uri2.lastIndexOf( "/" );
		if ( i2 == -1 )
			i2 = uri2.lastIndexOf( "\\" );
		if ( i1 == -1 && i2 == -1 )
			return true;
		if ( i1 == -1 )
			return false;
		if ( i2 == -1 )
			return false;
		String parent1 = 
			uri1.substring( 0, i1 );
		String parent2 = 
			uri2.substring( 0, i2 );
		return parent1.equalsIgnoreCase( parent2 );
	}

	public static String getRelativeURI( String uri ) {
		if ( uri == null )
			return null;
		int i = uri.lastIndexOf( "/" );
		if ( i == -1 )
			i = uri.lastIndexOf( "\\" );
		if ( i == -1 )
			return uri;
		return uri.substring( i + 1 );
	}

	public static String getAbsolutePath( String baseURI, String uri ) {

		if ( uri.indexOf( "/" ) > -1 )
			return uri;
		if ( uri.indexOf( "\\" ) > -1 )
			return uri;

		if ( baseURI != null ) {
		
			int i = baseURI.lastIndexOf( "/" );
			if ( i == -1 )
				i = baseURI.lastIndexOf( "\\" );
			if ( i == -1 )
				return uri;	// Can do nothing
			String parentPath = baseURI.substring( 0, i + 1 );
			return parentPath + uri;
		
		} else {
			return uri;
		}

	}

	public static String trimQuote( String str ) {
		if ( str == null )
			return str;
		if ( str.startsWith( "'" ) || str.startsWith( "\"" ) )
			str = str.substring( 1 );
		if ( str.endsWith( "'" ) || str.endsWith( "\"" ) )
			str = str.substring( 
					0, 
					( str.length() - 1 ) 
			);
		return str;
	}
	
}
