package com.japisoft.xmlform;

import java.awt.Point;

import javax.swing.JOptionPane;

import com.japisoft.framework.ApplicationModel;
import com.japisoft.xmlform.component.AbstractXMLFormComponent;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class UIToolkit {

	public static void dispatchError( String errorMessage ) {		
		JOptionPane.showMessageDialog( 
				ApplicationModel.MAIN_FRAME, 
				errorMessage, 
				"Error", 
				JOptionPane.ERROR_MESSAGE );		
	}

	public static boolean confirm( String confirmMessage ) {
		int val = JOptionPane.showConfirmDialog(
				ApplicationModel.MAIN_FRAME, 
				confirmMessage,
				"",
				JOptionPane.YES_NO_OPTION );
		return val == JOptionPane.YES_OPTION;
	}

	public static void warn( String confirmMessage ) {
		JOptionPane.showMessageDialog(
			ApplicationModel.MAIN_FRAME,
			confirmMessage,
			"Warning",
			JOptionPane.WARNING_MESSAGE );
	}

	public static void info( String message ) {
		JOptionPane.showMessageDialog(
				ApplicationModel.MAIN_FRAME,
				message );
	}
	
	public static Point getLocation( AbstractXMLFormComponent component ) {

		Point p = component.getLocation();
		AbstractXMLFormComponent parent = component.getXMLFormComponentParent();
		return getLocation( p, parent );

	}

	private static Point getLocation( Point location, AbstractXMLFormComponent ancestor ) {
		if ( ancestor == null || ancestor.getY() < 0 )
			return location;
		Point pancestor = ancestor.getLocation();
		location.translate( pancestor.x, pancestor.y );
		return getLocation( location, ancestor.getXMLFormComponentParent() );
	}
	
}
