package com.japisoft.xmlform.designer.properties;

import java.awt.Component;
import java.util.EventObject;

import javax.swing.JTable;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.TableCellEditor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class PropertiesEditor implements TableCellEditor, PropertyEditorListener {

	private PropertyEditor currentEditor = null;
	
	public Component getTableCellEditorComponent(
			JTable table, 
			Object value,
			boolean isSelected, 
			int row, 
			int column ) {

		currentEditor = 
			PropertyEditorFactory.getEditor( 
					( ( PropertiesModel )table.getModel() ).getPropertyAt( row ) );

		currentEditor.setPropertyEditorListener( this );
		currentEditor.setSelected( isSelected );
		
		return currentEditor.getView();		

	}
	
	private CellEditorListener l = null;

	public void addCellEditorListener( CellEditorListener l ) {
		this.l = l;
	}

	public void cancelCellEditing() {
	}

	public Object getCellEditorValue() {
		return currentEditor.getValue();
	}

	public boolean isCellEditable(EventObject anEvent) {
		return true;
	}

	public void removeCellEditorListener(CellEditorListener l) {
		this.l = null;
	}

	public boolean shouldSelectCell(EventObject anEvent) {
		return false;
	}

	public boolean stopCellEditing() {
		return true;
	}

	// ----------------------------------------------------------------------

	public void cancel() {
		this.l.editingCanceled( 
				new ChangeEvent( this ) );
	}

	public void stop() {
		this.l.editingStopped( 
				new ChangeEvent( this ) );
	}

}
