package com.japisoft.xmlform.designer.properties;

import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.JTable;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class PropertiesTable extends JTable {
	
	private PropertiesModel model = null;
	
	public PropertiesTable() {
		setModel( model = new PropertiesModel() );
		getColumnModel().getColumn( 1 ).setCellRenderer( 
				new PropertiesRenderer() );
		getColumnModel().getColumn( 1 ).setCellEditor( 
				new PropertiesEditor() );		
	}

	public void init( PropertyDescriptor[] descriptors ) {

		// Keep the x,y, width, height to the end
		
		ArrayList<PropertyDescriptor> l = 
			new ArrayList<PropertyDescriptor>();

		if ( descriptors != null ) {
			HashMap<String,PropertyDescriptor> hm = 
				new HashMap<String,PropertyDescriptor>();

			for ( int i = 0; i < descriptors.length; i++ ) {
				
				PropertyDescriptor pd = 
					descriptors[ i ];
				
				if ( pd == null )
					continue;
				
				if ( !pd.displayable() )
					continue;
				
				if ( !( "x".equals( pd.getName() ) || 
							"y".equals( pd.getName() ) ||
								"width".equals( pd.getName() ) ||
									"height".equals( pd.getName() ) ) ) {
					l.add( pd );
				} else
					hm.put( pd.getName(), pd );
				
			}

			if ( hm.containsKey( "x" ) )
				l.add( hm.get( "x" ) );
			if ( hm.containsKey( "y" ) )
				l.add( hm.get( "y" ) );
			if ( hm.containsKey( "width" ) )
				l.add( hm.get( "width" ) );
			if ( hm.containsKey( "height" ) )
				l.add( hm.get( "height" ) );									
		}
		
		model.init( l );

	}

}

