package com.japisoft.xmlform.designer.properties.editors;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JComboBox;

import com.japisoft.xmlform.designer.properties.PropertyEditor;
import com.japisoft.xmlform.designer.properties.PropertyEditorListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class BooleanEditor extends JComboBox implements PropertyEditor, ItemListener {

	public BooleanEditor() {
		addItem( "false" );
		addItem( "true" );
	}

	@Override
	public void addNotify() {
		super.addNotify();
		addItemListener( this );
	}

	@Override
	public void removeNotify() {
		super.removeNotify();
		removeItemListener( this );
	}

	public Object getValue() {
		return "true".equals( 
				getSelectedItem() );
	}

	public Component getView() {
		return this;
	}

	private PropertyEditorListener listener = null;
	
	public void setPropertyEditorListener( PropertyEditorListener listener ) {
		this.listener = listener;
	}

	public void setSelected( boolean selected ) {
	}

	public void setValue(Object value) {
		setSelectedItem( 
			( ( Boolean )value ).booleanValue() ? 
					"true" : "false" );
	}

	public void itemStateChanged(ItemEvent e) {
		if ( listener != null )
			listener.stop();
	}
	
}
