package com.japisoft.xmlform.designer.properties.editors;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JColorChooser;

import com.japisoft.xmlform.designer.properties.PropertyEditor;
import com.japisoft.xmlform.designer.properties.PropertyEditorListener;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ColorEditor extends JButton implements PropertyEditor, ActionListener {

	private Color color = null;
	
	public ColorEditor() {
		setIcon( new ColorIcon() );
	}
	
	@Override
	public void addNotify() {
		super.addNotify();
		addActionListener( this );
	}

	@Override
	public void removeNotify() {
		super.removeNotify();
		removeActionListener( this );
	}
	
	public Object getValue() {
		return color;
	}

	public Component getView() {
		return this;
	}

	PropertyEditorListener l;
	
	public void setPropertyEditorListener(PropertyEditorListener listener) {
		this.l = listener;
	}

	public void setSelected(boolean selected) {
	}

	public void setValue(Object value) {
		this.color = ( Color )value;
		repaint();
	}

	public void actionPerformed(ActionEvent e) {
		Color tmp = JColorChooser.showDialog( this, "Select a color", color );
		if ( tmp != null ) {
			this.color = tmp;
			l.stop();
		}
	}
	
	/////////////////////////////////////////////////////////////////////////


	class ColorIcon implements Icon {
		public int getIconHeight() {
			return 16;
		}
		public int getIconWidth() {
			return 16;
		}
		public void paintIcon(Component c, Graphics g, int x, int y) {
			if ( color != null ) {
				g.setColor( color );
				g.fillRect( x, y, 16, 16 );
			}
		}
	}

}
