package com.japisoft.xmlpad;

import java.awt.Color;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface DocumentColorAccessibility {

	/** Define a color for this tagName. Use a <code>null</code> color for removing it */
	public void setColorForTag( String tagName, Color c );

	/** @return a custom color for this tagName */ 
	public Color getColorForTag( String tagName );
	
	/** @return <code>true</code> if a custom color exists for this tagName */
	public boolean hasColorForTag( String tagName );	

	/** Choose a particular color for an attribute. Use the color <code>null</code> for removing it */
	public void setColorForAttribute( String attributeName, Color c );
		
	/** @return the user custom color for this attribute */
	public Color getColorForAttribute( String attributeName );

	/** @return <code>true</code> if this attribute has a custom color */ 
	public boolean hasColorForAttribute( String attributeName );
	
	/** Choose a particular color for a tag prefix. Use the color <code>null</code> for removing it */
	public void setColorForPrefix( String prefixName, Color c );
	
	/** @return a custom color for this prefix name */
	public Color getColorForPrefix( String prefixName );

	/** @return <code>true</code> if a color exist for this prefixName */
	public boolean hasColorForPrefix( String prefixName );	

	/** Choose a particular background color for a tag prefix. Use the color <code>null</code> for removing it */
	public void setBackgroundColorForPrefix( String prefixName, Color c );
	
	/** @return a custom background color for this prefix name */
	public Color getBackgroundColorForPrefix( String prefixName );

	/** @return <code>true</code> if a background color exist for this prefixName */
	public boolean hasBackgroundColorForPrefix( String prefixName );	

	/** This is only for inner usage, it mustn't be called by the user */
	void dispose();
	
}
