package com.japisoft.xmlpad;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;

import com.japisoft.xmlpad.action.ActionModel;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
class XMLContainerAccessibility implements Accessibility {

	XMLContainer container;
	
	XMLContainerAccessibility( XMLContainer container ) {
		this.container = container;
	}
	
	public String getText() {
		return container.getText();
	}

	public boolean invokeAction(String actionName) {
		return ActionModel.activeActionByName(actionName,
				container, container.getEditor());
	}

	public void read(Reader reader) throws IOException {
		BufferedReader br = new BufferedReader(reader);
		try {
			StringBuffer sb = new StringBuffer();
			String line = null;
			while ((line = br.readLine()) != null) {
				sb.append(line)
						.append(System.getProperty("line.separator"));
			}
			setText(sb.toString());
		} finally {
			br.close();
		}
	}

	public void setText(String text) {
		container.setText(text);
	}

	public void write(Writer writer) throws IOException {
		BufferedWriter bw = new BufferedWriter(writer);
		try {
			bw.write(getText());
		} finally {
			bw.close();
		}
	}

	public void dispose() {
		this.container = null;
	}	
	
}
