package com.japisoft.xmlpad;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLIntegrity {
	private boolean parseBeforeSaving;
	private boolean protectTag;

	/**
	 * @return true if the document is parsed before saving. If the document
	 * is not valid, the save action has no effect. By default false.
	 */
	public boolean isParseBeforeSaving() {
		return parseBeforeSaving;
	}

	/**
	 * Decide to parse the document before saving. If the document is wrong
	 * the saving action is canceled.
	 * @param b
	 */
	public void setParseBeforeSaving(boolean b) {
		parseBeforeSaving = b;
	}

	/**
	 * A protection mean user can't edit it
	 * @return true is a protection is available on tag. */
	public boolean isProtectTag() {
		return protectTag;
	}

	/**
	 * If true, it protects all tag from user insert or remove
	 * @param b true to protect all tag. */
	public void setProtectTag(boolean b) {
		protectTag = b;
	}

}
