package com.japisoft.xmlpad;

import java.util.Properties;
import java.util.Enumeration;
import java.net.URL;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class XMLPadProperties {

	static Properties prop = new Properties();

	static {
		try {
			ClassLoader cl = ClassLoader.getSystemClassLoader();
			URL url = cl.getResource("xmlpad.properties");
			if (url != null) {
				try {
					prop.load(url.openStream());
				} catch (Throwable th) {
				}
			}
		} catch (Throwable th) {
			System.out.println(
				"Can't load xmlpad.properties, use default properties");
		}
	}

	/**
	 * @return a XMLPad property value */
	public static String getProperty(String name, String def) {
		return prop.getProperty(name, def);
	}

	/** Reset a property by this one */
	public static void setProperty( String name, String value ) {
		prop.setProperty( name, value );
	}

	/** Here a way for overriding the default Properties content */
	public static void setPropertyContent( Properties p ) {
		prop = p;
	}

	public static Enumeration getProperties() {
		return prop.keys();
	}
}

// XMLPadProperties ends here
