package com.japisoft.xmlpad.action;

import com.japisoft.xmlpad.editor.*;
import com.japisoft.xmlpad.*;
import java.util.Vector;

import javax.swing.Action;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class ActionGroup extends Vector {

	public ActionGroup(String name) {
		setName(name);
	}

	/** Updage action for this group for working on this editor and this container */
	public void resetActionState( XMLEditor editor, XMLContainer container ) {
		for ( int i = 0; i < size(); i++ ) {
			//if ( !(  get( i ) instanceof UnResetableState ) ) {
				if ( get( i ) instanceof XMLAction ) {
					( ( XMLAction )get( i ) ).setXMLContainer( container );
					( ( XMLAction )get( i ) ).setXMLEditor( editor );
				}
			//}
		}
	}

	/** @return a current XMLAction matching this name */
	public Action getActionByName( String name ) {
		for ( int i = 0; i < size(); i++ ) {
			Action a = ( Action )get( i );
			if ( name.equals( getActionName( a ) ) ) {
				return a;
			}
		}
		return null;
	}

	private String getActionName( Action a ) {
		if ( a instanceof XMLAction ) {
			return ( ( XMLAction )a ).getName();
		} else {
			return ( String )a.getValue( Action.NAME );
		}
	}

	private String name;

	/** Set a name for this group */
	public void setName(String name) {
		this.name = name;
	}

	/** @return the name of this group */
	public String getName() {
		return name;
	}

	/** Add a new XML action */
	public void addAction( Action a) {
		add( a );
	}

	/** Remove a known XML action */
	public void removeAction( Action a ) {
		remove( a ); 
	}

	/** Remove an action by name */	
	public void removeAction( String name ) {
		Action a = getActionByName( name );
		if ( a != null )
			removeAction( a );
	}

}
