package com.japisoft.xmlpad.action;

import com.japisoft.xmlpad.action.edit.CopyAction;
import com.japisoft.xmlpad.action.edit.CutAction;
import com.japisoft.xmlpad.action.edit.FastCommentUncommentAction;
import com.japisoft.xmlpad.action.edit.PasteAction;
import com.japisoft.xmlpad.action.edit.RedoAction;
import com.japisoft.xmlpad.action.edit.UndoAction;
import com.japisoft.xmlpad.action.file.InsertAction;
import com.japisoft.xmlpad.action.file.LoadAction;
import com.japisoft.xmlpad.action.file.NewAction;
import com.japisoft.xmlpad.action.file.SaveAction;
import com.japisoft.xmlpad.action.file.SaveAsAction;
import com.japisoft.xmlpad.action.other.SplitAction;
import com.japisoft.xmlpad.action.other.SplitActionHorizontal;
import com.japisoft.xmlpad.action.search.SearchAction;
import com.japisoft.xmlpad.action.xml.CommentAction;
import com.japisoft.xmlpad.action.xml.FormatAction;
import com.japisoft.xmlpad.action.xml.ParseAction;
import com.japisoft.xmlpad.tree.action.AddHistoryAction;
import com.japisoft.xmlpad.tree.action.CleanHistoryAction;
import com.japisoft.xmlpad.tree.action.CommentNode;
import com.japisoft.xmlpad.tree.action.CopyNode;
import com.japisoft.xmlpad.tree.action.CutNode;
import com.japisoft.xmlpad.tree.action.EditNode;
import com.japisoft.xmlpad.tree.action.NextAction;
import com.japisoft.xmlpad.tree.action.PreviousAction;
import com.japisoft.xmlpad.tree.action.SelectNode;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface ActionSet {

	/** New action */
	public static String NEW_ACTION =
		NewAction.ID;

	/** Undo action */
	public static String UNDO_ACTION =
		UndoAction.ID;

	/** Redo action */
	public static String REDO_ACTION =
		RedoAction.ID;

	/** Copy action */
	public static String COPY_ACTION =
		CopyAction.ID;

	/** Cut action */
	public static String CUT_ACTION =
		CutAction.ID;

	/** Paste action */
	public static String PASTE_ACTION =
		PasteAction.ID;

	/** Refresh action */
	public static String PARSE_ACTION =
		ParseAction.ID;

	/** Search action */
	public static String SEARCH_ACTION =
		SearchAction.ID;

	/** Comment action */
	public static String COMMENT_ACTION =
		CommentAction.ID;

	/** Fast comment/uncomment action */
	public static String FAST_COMMENT_ACTION =
		FastCommentUncommentAction.ID;

	/** SaveAs action */
	public static String SAVEAS_ACTION =
		SaveAsAction.ID;

	/** Save action */
	public static String SAVE_ACTION =
		SaveAction.ID;

	/** Insert file action */
	public static String INSERT_ACTION =
		InsertAction.ID;

	/** Load action */
	public static String LOAD_ACTION =
		LoadAction.ID;

	/** Split vertically action */
	public static String SPLIT_ACTION =
		SplitAction.ID;

	/** Split horizontally action */
	public static String SPLIT_ACTION_HOR =
		SplitActionHorizontal.ID;
		
	/** Format action */
	public static String FORMAT_ACTION =
		FormatAction.ID;

	// TREE

	/** Tree select node */
	public static String TREE_SELECTNODE_ACTION =
		SelectNode.ID;
		
	/** Tree copy node */
	public static String TREE_COPYNODE_ACTION =
		CopyNode.ID;

	/** Tree cut node */
	public static String TREE_CUTNODE_ACTION =
		CutNode.ID;
	
	/** Tree edit node */
	public static String TREE_EDITNODE_ACTION =
		EditNode.ID;

	/** Tree comment node */
	public static String TREE_COMMENTNODE_ACTION =
		CommentNode.ID;

	/** Retreive the previous history node */
	public static String TREE_PREVIOUS_ACTION =
		PreviousAction.ID;

	/** Retreive the next history node */
	public static String TREE_NEXT_ACTION =
		NextAction.ID;
	
	/** Clean the history */
	public static String TREE_CLEANHISTORY_ACTION =
		CleanHistoryAction.ID;
	
	/** Add the current node in the history */
	public static String TREE_ADDHISTORY_ACTION =
		AddHistoryAction.ID;

}
