package com.japisoft.xmlpad.action.edit;

import java.awt.Point;

import javax.swing.JOptionPane;
import javax.swing.text.BadLocationException;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.action.XMLAction;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DuplicatePreviousSiblingNodeAction extends XMLAction {

	public boolean notifyAction() {
		FPNode node = container.getCurrentNode();
		if ( node == null ) {
			JOptionPane.showMessageDialog( container.getView(), "Can't find a previous sibling node", "Error", JOptionPane.ERROR_MESSAGE );
			return false;
		}

		int caret = container.getEditor().getCaretPosition();
		
		FPNode previousSiblingCandidate = null;
		
		for ( int i = 0; i < node.childCount(); i++ ) {
			FPNode child = node.childAt( i );
			if ( child.getStoppingOffset() < caret ) {
				previousSiblingCandidate = child;
			} else
				break;
		}
		
		if ( previousSiblingCandidate != null ) {

			Point n = CopyNodeAction.getNodeOffset( previousSiblingCandidate );
			try {
				String mustCopy = container.getEditor().getText( n.x, n.y - n.x + 1 );
				
				container.getEditor().insertText( mustCopy );
				
			} catch (BadLocationException e) {
				JOptionPane.showMessageDialog( container.getView(), "Can't find a previous sibling node", "Error", JOptionPane.ERROR_MESSAGE );							
			}
			
		} else {

			JOptionPane.showMessageDialog( container.getView(), "Can't find a previous sibling node", "Error", JOptionPane.ERROR_MESSAGE );			
	
		}

		return false;
	}

}
 
