package com.japisoft.xmlpad.action.edit;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.action.XMLAction;

import java.awt.Point;

import javax.swing.text.BadLocationException;
import javax.swing.text.Segment;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class TrimAction extends XMLAction {

	@Override
	public boolean notifyAction() {
		if ( container.getTreeListeners() == null )
			return INVALID_ACTION;
		if ( container.getTree() == null )
			return INVALID_ACTION;
		FPNode node = container.getCurrentNode();
		if ( node.isTag() ) {
			if ( node.childCount() == 0 ) {
				return INVALID_ACTION;
			}
			node = node.childAt( 0 );
			if ( node.isTag() )
				return INVALID_ACTION;
		}
		Point p = CopyNodeAction.getNodeOffset( node );
		try {
			for ( int i = 1; i < 100; i++ ) {
				String tmp = container.getEditor().getText( p.x - i, 1 );
				if ( Character.isWhitespace( tmp.charAt( 0 ) ) ) {
					p.x--;
					i--;
					continue;
				} else
					break;
			}
			for ( int i = 0; i < 100; i++ ) {
				String tmp = container.getEditor().getText( p.y + i, 1 );
				if ( Character.isWhitespace( tmp.charAt( 0 ) ) ) {
					p.y++;
					continue;
				} else
					break;
			}			
		
			container.getEditor().select( p.x, p.y );
			String txt = container.getEditor().getSelectedText();
			txt = txt.trim();
			container.getEditor().replaceSelection( txt );
			return VALID_ACTION;
		} catch( BadLocationException exc ) {
			return INVALID_ACTION;
		}
	}

}
