package com.japisoft.xmlpad.helper.handler.schema.dtd;

import com.japisoft.dtdparser.node.DTDNode;
import com.japisoft.dtdparser.node.EntityDTDNode;
import com.japisoft.dtdparser.node.RootDTDNode;
import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.editor.XMLPadDocument;
import com.japisoft.xmlpad.helper.handler.schema.AbstractEntityHandler;
import com.japisoft.xmlpad.helper.model.EntityDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DTDEntityHandler extends AbstractEntityHandler {

	private RootDTDNode root;

	public DTDEntityHandler(  
			RootDTDNode root ) {
		this.root = root;
	}

	public void dispose() {
		super.dispose();
		this.root = null;
	}	

	protected void installDescriptors(
			FPNode currentNode,
			XMLPadDocument document, 
			int offset, 
			String addedString ) {
		for ( int i = 0; i < root.getDTDNodeCount(); i++ ) {
			DTDNode node = root.getDTDNodeAt( i );
			if ( node instanceof EntityDTDNode ) {
				EntityDTDNode entity = ( EntityDTDNode )node;
				EntityDescriptor ed = new EntityDescriptor(
						addedString +
						entity.getName(),
						entity.getValue() );
				ed.setComment(
						entity.getNodeComment() );
				addDescriptor( ed );
			}
		}
	}	

}
