package com.japisoft.xmlpad.helper.handler.schema.dtd;

import java.util.ArrayList;

import com.japisoft.dtdparser.node.AttributeDTDNode;
import com.japisoft.dtdparser.node.ElementDTDNode;
import com.japisoft.xmlpad.helper.model.AttDescriptor;
import com.japisoft.xmlpad.helper.model.TagDescriptor;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DTDTagDescriptor extends TagDescriptor {

	public DTDTagDescriptor( ElementDTDNode ref ) {

		super( ref.getName(), null, ref.isEmptyElement() );
		
		setComment( ref.getNodeComment() );
		
		ArrayList atts = null;
		for ( int i = 0; i < ref.getDTDNodeCount(); i++ ) {
			
			if ( ref.getDTDNodeAt( i ).isAttribute() ) {
				AttributeDTDNode attNode = ( AttributeDTDNode )ref.getDTDNodeAt( i );
				if ( atts == null )
					atts = new ArrayList();
				atts.add( new DTDAttDescriptor( attNode ) );
			}

		}

		if ( atts != null ) {
			
			AttDescriptor[] _ = new AttDescriptor[ atts.size() ];
			for ( int i = 0; i < atts.size(); i++ )
				_[ i ] = ( AttDescriptor )atts.get( i );
			setAttDescriptor( _ );

		}
	}
	
	
	
}
