package com.japisoft.xmlpad.helper.model;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenuItem;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;

import com.japisoft.xmlpad.editor.XMLPadDocument;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class EntityPopup extends CommonPopup {
	private EntityDescriptor[] entities;
	private int offset;
	private Document doc;	
	
	public EntityPopup( EntityDescriptor[] entities, int offset, Document doc ) {
		super( "Entities" );
		this.entities = entities;
		this.offset = offset;
		this.doc = doc;
		buildit();
	}

	protected void buildit() {
		for ( int i = 0; i < entities.length; i++ ) {
			add( buildMenuItem( entities[ i ] ) );
		}
	}
	
	protected JMenuItem buildMenuItem( EntityDescriptor ed ) {
		JMenuItem item = getMenuItem();
		item.setText( ed.getValue() + " (" + ed.getName() + ")" );
		return item;
	}

	protected void notifySelection( int selection ) {
		if ( selection > 0 ) {
			EntityDescriptor ed = entities[ selection ];
			try {
				doc.insertString( offset, ed.getBuiltEntity(), null );
			} catch( BadLocationException exc ) {
			}
		} else {
			try {
				doc.insertString( offset, "&;", null );
				( ( XMLPadDocument )doc ).getCurrentEditor().setCaretPosition(
				( ( XMLPadDocument )doc ).getCurrentEditor().getCaretPosition() - 1 );
			} catch( BadLocationException exc ) {
			}
		}
	}
}
