package com.japisoft.xmlpad.look;

import java.awt.*;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.tree.DefaultTreeModel;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.editor.XMLEditor;
import com.japisoft.xmlpad.tree.renderer.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class DefaultLook implements Look {

	public DefaultLook() {
		super();
		UIManager.put( "xmlpad.helper.backgroundColor", 
			new Color( 230, 230, 250 ) );
	}

	/** Change the graphics attributes of this realtime tree */
	public void install(XMLContainer container, JTree tree) {
		//JPF default font
		FastTreeRenderer renderer = new FastTreeRenderer( container );
		tree.setCellRenderer(renderer);
		tree.setModel( new DefaultTreeModel( new FPNode(FPNode.TAG_NODE, "" ) ) );
		
		//JPF
	}

	/** Change the graphics attributes of this editor */
	public void install(XMLContainer container, XMLEditor editor) {

		// NEWS

		// Color

		editor.setColorForEntity(Color.blue);
		editor.setColorForDeclaration(Color.gray.darker());
		editor.setColorForDeclarationStart( Color.gray );
		editor.setColorForDeclarationEnd( Color.gray );
		editor.setColorForDocType( editor.getColorForDeclaration() );
		editor.setColorForDocTypeStart( Color.gray );
		editor.setColorForDocTypeEnd( Color.gray );
		editor.setColorForDocTypeBackground( new Color( 220, 240, 220 ) );
		editor.setColorForLiteral(Color.blue);
		editor.setColorForTag(new Color(50, 150, 50));
		editor.setColorForInvalid(Color.red);
		editor.setColorForText(Color.black);
		editor.setColorForAttribute(new Color(20, 150, 150));
		editor.setColorForTagDelimiter( Color.gray );
		editor.setColorForTagBackground( new Color( 250, 250, 220 ) );
		editor.setColorForDeclarationBackground( new Color( 240, 240, 240 ) );
		editor.setColorForEntityBackground( new Color( 220, 240, 220 ) );
		editor.setColorForCommentBackground( new Color( 220, 220, 240 ) );
		editor.setColorForComment( editor.getColorForDeclaration() );
		editor.setColorForCommentStart( Color.gray );
		editor.setColorForCommentEnd( Color.gray );
		editor.setColorForTagUnderline(Color.gray);
		editor.setColorForAttributeSeparator(Color.black);
		editor.setColorForTagEnd(Color.black );
		editor.setColorForNameSpace(new Color(20, 100, 100));
		editor.setColorForCDATA( Color.black );
		editor.setColorForCDATAStart( Color.gray );
		editor.setColorForCDATAEnd( Color.gray );
		editor.setColorForCDATABackground( Color.gray );
		editor.setColorForTagBorderLine( Color.gray );
		editor.setColorForLineSelection( new Color( 100, 100, 255 ) );
		editor.setColorForLineError( Color.red );
		
		// For DTD

		editor.setColorForDTDElement( Color.CYAN.darker() );
		editor.setColorForDTDAttribute( Color.GREEN.darker() );
		editor.setColorForDTDEntity( Color.ORANGE.darker() );
		editor.setColorForDTDNotation( Color.CYAN.darker() );
		
		// Font

		editor.setCaretColor(Color.black);

		editor.setBackground(Color.white);
		editor.setForeground(Color.black);

		editor.getCaret().setBlinkRate(500);
	}

	public void uninstall(XMLEditor editor) {
	}

}

// DefaultLook ends here
