package com.japisoft.xmlpad.look;

import java.awt.Color;

import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.editor.XMLEditor;
import com.japisoft.xmlpad.tree.renderer.FastTreeRenderer;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class IELook implements Look {

	public void install( XMLContainer container, JTree tree) {
		FastTreeRenderer renderer = new FastTreeRenderer( container );
		renderer.setElementIcon( null );
		renderer.setTextIcon( null );
		renderer.setTextColor( Color.blue );
		renderer.setTextFont(tree.getFont());
		tree.setCellRenderer(renderer);
		tree.setModel(
				new DefaultTreeModel(
						new FPNode( FPNode.TAG_NODE, "" ) ) );
	}

	/** Change the graphics attributes of this editor */
	public void install( XMLContainer container, XMLEditor editor) {
		// NEWS

		// Color

		editor.setColorForEntity(Color.blue);
		editor.setColorForComment( Color.gray );
		editor.setColorForDeclaration(Color.gray.darker());
		editor.setColorForDocType(Color.blue );
		editor.setColorForLiteral(Color.black);
		editor.setColorForTag(new Color( 222, 38, 18 ) );
		editor.setColorForInvalid(Color.red);
		editor.setColorForText(Color.black);
		editor.setColorForAttribute( new Color( 222, 38, 18 ) );
		editor.setColorForTagDelimiter(Color.green.darker());
		editor.setColorForTagUnderline(Color.gray);
		editor.setColorForAttributeSeparator(Color.blue);
		editor.setColorForTagEnd(Color.black);
		editor.setColorForNameSpace(new Color(222, 38, 18));
		editor.setColorForCDATA(editor.getColorForDeclaration());

		editor.setColorForTagDelimiter( Color.blue );
		editor.setColorForTagEnd( Color.blue );

		editor.setCaretColor(Color.black);

		editor.setBackground(Color.white);
		editor.setForeground(Color.black);

		editor.setColorForTagBorderLine( Color.gray );

		editor.getCaret().setBlinkRate(500);
	}

	public void uninstall(XMLEditor editor) {

	}

}
