package com.japisoft.xmlpad.tree.action;

import javax.swing.SwingUtilities;
import javax.swing.tree.TreePath;

import com.japisoft.framework.xml.parser.node.FPNode;
import com.japisoft.xmlpad.action.edit.SelectTagAction;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class SelectNode extends AbstractTreeAction {

	public static final String ID = SelectNode.class.getName();

	public SelectNode() {
		super();
	}

	protected void actionForSelection( TreePath tp ) {
		final FPNode n = ( FPNode )tp.getLastPathComponent();
		if ( n != null ) {
			SwingUtilities.invokeLater(
				new Runnable() {
					public void run() {
						SelectTagAction.selectNode( container, n );						
					}
				}
			);
		}
	}

	protected String getDefaultLabel() {
		return "Select text";	
	}
	
}
