// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a
// valid version and has all rights on the product.


package com.japisoft.xpath;

import com.japisoft.xpath.node.*;
/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public interface XPathResolver {
    public static final String ABBREVIATED_SELF = ".";
    public static final String ABBREVIATED_ANCESTOR = "..";
    public static final String ABBREVIATED_DESCENDANT = "//";
    public static final String ABBREVIATED_ATTRIBUTE = "@";

    public static final String ABBREVIATED_NAMETEST = "*";

    /**At the end of the parsing process, this value contains the result set
       @return the current node set */
    public AbstractNode getRootParsedNode();

    /** Select the root node */
    public void root();

    /** Prepare the current nodeSet */
    public void nextLocationPath();
    
    /** Prepare the current nodeSet */
    public void nextPredicate();

    /** Next expression for the predicate */
    public void nextExpression();

    /** Reset the current axis :
	ancestor, ancestor-or-self, attribute, child, descendant, descendant-or-self, following, following-sibling, namespace  parent, preceding, preceding-sibling, self.
    */
    public void axis( String axisName );

    /** '.', '..', '//' */
    public void abbreviatedAxis( String axisName );

    /** Reset the nameTest after the axis name. Can be '*' */
    public void nameTest( String nameTest, String namespacePrefix );

    /** Reset the processing instruction after the axis name
	@param name Processing instruction
	@param argument Argument for the processing instruction, can be <code>null</code>
    */
    public void processingInstruction( String name, String argument );

    /** Reset the nodeType : comment , text , processing-instruction , node */
    public void nodeType( String nodeType );

    /** or operator */
    public static final int OR = 1;
    /** and operator */
    public static final int AND = 2;
    /** = operator */
    public static final int EQUAL = 3;
    /** != operator */
    public static final int NOT_EQUAL = 4;
    /** < operator */
    public static final int INF = 5;
    /** > operator */
    public static final int SUP = 6;
    /** <= operator */
    public static final int INFE = 7;
    /** >= operator */
    public static final int SUPE = 8;
    /** + operator */
    public static final int ADD = 9;
    /** - operator */
    public static final int MINUS = 10;
    /** * operator */
    public static final int STAR = 11;
    /** div operator */
    public static final int DIV = 12;
    /** mod operator */
    public static final int MOD = 13;
    /** union operator */
    public static final int UNION = 14;

    /** Evaluate the current predicate with binary operator */
    public void binaryOperator( int type );

    /** Evaluate the current predicate with this binary operator
     * @param opExt can be equal to 'div' or 'mod' */
    public void binaryOperator( String opExt );

    /** Evaluate the current predicate expression with an unary operator */
    public void unaryOperator( int type );

    /** Evaluate the current variable */
    public void variable( String name );

    /** Current literal */
    public void literal( String literal );

    /** Current number */
    public void number( String number );

    /** Current function name */
    public void functionName( String qname );

    /** Add a parameter */
    public void nextParam();

    /** Evaluate the current function */
    public void nextFunction();

}

// XPathResolver ends here




