// (c) ALEXANDRE BRILLANT : http://www.japisoft.com
// All this work is confidential, you have rights to 
// change and evolve it for your products but you
// have no rights to sell it, propose concurrent works.
// Morever any changes to bugs or evolutions should
// be send to JAPISOFT that needs to maintain a 
// valid version and has all rights on the product.


package com.japisoft.xpath.node;

import com.japisoft.xpath.*;

/**
EditiX Open source XML Editor
https://www.editix.com


Sources Edition :

Our software is available under both a commercial and a non-commercial license :

- If you are a non-commercial user, you are free to use the software for any non-commercial purpose under the terms of the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International Public License. 

- If you are a commercial user and you want to use the software for commercial purposes, you must purchase a commercial license. The details are inside the license-commercial.txt file.



Binaries Edition :

- You can purchase a license for binaries usage using the purchasing page at https://www.editix.com. Each binary version can be downloaded on https://www.editix.com.



Please contact us at https://www.editix.com for more information on purchasing a commercial license.


@author (c) 2010-2023 Alexandre Brillant



*/
public class Predicate extends AbstractNode {
    public Predicate() {
	super();
    }

    public Object eval( XPathContext context ) {
	// Eval the content

        // Save the context
        NodeSet tempNS = context.getContextNodeSet();
        int tempLocation = context.getContextPosition();

	Object obj = getNodeAt( 0 ).eval( context );

        // Restore it
        context.setContextNodeSet( tempNS );
        context.setContextPosition( tempLocation );

	if ( obj instanceof Double ) {
	    Double d = ( Double )obj;
	    return new Boolean( ( double )( context.getContextPosition() + 1 ) == d.doubleValue() );
	} else
	    if ( obj instanceof Boolean ) {
		return ( Boolean )obj;
	    } else
		if ( obj instanceof NodeSet ) {
		    return new Boolean( ( ( NodeSet )obj ).size() > 0 );
		} else
		    throw new RuntimeException( "Invalid predicate" );
    }
}

// Predicate ends here
